;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Gerhard's MiniGolf
; Rhnweg-Software
; Freeware
;
; ab Windows95 mit mind. DirectX 7
; written in Blitz3D 1.88
;
; Version 0.273
; 01.02.2005
; grossmann.gg@gmx.de
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
; Verwendet wurden folgende Programme:
; Windows 98 SE
; Micrografx Picture Publisher 8.0.1 (Malprogramm, ltere Version, gab's mal fuer 10 DM)
; MilkShape3D 1.7.1 (25 Euro)
; Total Terrain 2 von Robin King (free)
; und natuerlich Blitz3D (Version 1.88)
;
;
; Die Ballphysik ist sehr einfach, manche Bahnen lassen sich damit nicht verwirklichen.
; Bahnerweiterungen (zustzliche Bahnen usw.) sind auch nicht vorgesehen. (So toll
; ist weder Minigolfspielen noch dieses Programm)
;
; Tips:
; Sollte sich der Ball nicht beruhigen, (bei Tempo Null erscheint normalerweise der Schlger), 
; kann man mit F5 oder ESC den Schlger 'holen'.
; Nicht durchscheinender Hintergrund whrend der Anzeige der Hilfe und Optionen: F2.
; Im Spiel:
; ... kann man mit der Taste V die Mwe einmal vorbeifliegen lassen; 
; ... kann man mit der Taste B die Mwe einmal (beim Ball) abstrzen lassen; 
; ... kann man mit der Taste M die Maus mit der Beule aus dem Loch kommen lassen;
; ... kann man mit der Taste N Nessie hervorlocken.

; Geholfen haben:
; Joseph 'Phish' Humfrey mit seiner Pool-Billard - Demo;
; Andrew Constant mit 'Rebounding balls';
; Matt Davey mit 'Matts balls' aus den B3D-samples;
; ein Unbekannter, von dem die 3 Zeilen Balldrehungs-Code stammen.
; Die Partikel-Routine stammt urspruenglich von Rob Cummings.
; Das Speichern mit verkleinertem Screenshot stammt aus meinem (noch unveroeffentlichen)
; BreakOut-Clone.
; Sounds: Free sounds aus dem Internet
; Und vieles stammt natuerlich aus dem deutschen Gemeinschaftsforum (www.blitzforum.de).
;
;
; to do:
; Lampe umfaerben und wechselnde Hintergrundbahnen(?)
; Wassersound bei Bahn 18 (Ball im Wasser) zu heftig in Ballbewegung()
;
;
; nach Test: Mausklick zum Ballstoppen rausnehmen!
;            Keyhit(62) im Turnier abschalten!
;
; Sonderregelungen bei Bahnen 11 und 18 (Vorsicht bei Neuzusammenstellung Bahnen (auch bei 16!)):
; -> Bahn 11: Maus kommt nicht, Vulkanausbruch
; -> Bahn 18: Springbrunnen
;
Global scrW = 1024
Global scrH = 768
Global scrD = 16
Global anzGfx, soundon=1, hinweise=2, bahn=1, showfps, training=1, blickwahl=0, rueckstellen=1
Global aktrueck, aktsound, akthin, aktshowfps, akttraining, aktblickwahl
Global mausempf# = 0.05 ; Mausempfindlichkeit fuer Blickwinkelaenderung
Global mausdreh  = 10   ; Bilddrehung in Grad beim Drehen am Mausrad
Global aktW, aktH, aktD ; Bildschirmaufloesung
Ini_Lesen()
;
anzGfx = CountGfxModes3D()
If Not anzGfx Then RuntimeError "Kein 3D Graphikmodus gefunden!"
If Not GfxModeExists(scrW,scrH,scrD) Then RuntimeError "Bildschirm-Auflsung "+Str$(scrW)+" x "+ Str$(scrH)+ " x "+ Str$(scrD)+ " wird nicht untersttzt. Bitte Datei Minigolf.ini ndern oder lschen."
Graphics3D scrW,scrH,scrD
;
Global unten = scrH-90
aktW = scrW
aktH = scrH
aktD = scrD
scrW = scrW / 2
scrH = scrH / 2
aktsound = soundon
akthin = hinweise
aktshowfps = showfps
akttraining = training
aktblickwahl = blickwahl
aktmausdreh = mausdreh
aktmausempf# = mausempf#
aktrueck = rueckstellen
;
SetBuffer BackBuffer()
;
Global camera = CreateCamera()
CameraClsColor camera,205,205,205
Global campivot = CreatePivot()
;
Global light = CreateLight()
RotateEntity light,60,0,0
;
SeedRnd MilliSecs()
;
; Kollisions-Konstanten
Const COLL_BALL=1, COLL_KREIS=2, COLL_WALL90=3, COLL_WALL180=4, COLL_BODEN=5
Const COLL_WALL45=6, COLL_WALL135=7, COLL_POLLER=9, COLL_HUB=10
; sonstige Konstanten
Const rollwiderstand# = 1.03 ; speed-Verringerung beim Rollen
Const h_faktor#  = 0.7 ; Huepfhoehe
Const h_faktor2# = 0.5 ;
Const drehen#    = 200 ; Ballrotation
Const gravity#  = 0.06 ; Schwerkraft
Const maxSpeed#  = 0.8 ; Ballhuepfen beginnt bei > maxSpeed#
Const lochSpeed# = 0.25 ; Ball geht ins Loch bei (x<0.2 und z<0.2 und) speed < lochSpeed
; Globale Variablen
Global bbreit#   = 0.02 ; +/- Tempo bei Schlagstaerke
Global mauswieoft = Rand(15,20) ; Haeufigkeit des Erscheinens der 'echten' Maus
Global wand45, wand135, txtspeichern, txtladen, massiv, nessiebauch, nessieY#, nessieZ#
Global boden, kreis1, wand90, wand180, ball, putter, pfeil, bahnNr, poller, poller2, nessiekopf
Global powerup, pointer, speichern, maus2, power, titel, txtfrei, tasten, wechsel, wechselX
Global ang#, xi#, yi#, zi#, a#, x#, y#, z#, speed#, fischauf2, fischneu2, feuer, rauch
Global ballstatus, camstatus, huepfen, bahnok, tasteX, tasteY, spritzer, wechselplus, WEnde
Global putX#, putZ#, putZoom#, putRotX#, pfeilX#, pfeilZ#, amAbschlag, fischauf, fisch2
Global breite, anzahl, gesamt, max6, rahmen, mauskommt, wartezeit, nessiedreh, nzeit, nessiezeit
Global bergalt#, bergneu#, bergdiff#, abschlag, fntcouNew8f, fisch, fischneu, poller3
Global eingabe, weiter=1, rahmen2, rahmen3, punkt, erstesmal, loeschen, wasser2, hub, nessiekommt
Global Bild1, Bild2, Bild3, bild1da, bild2da, bild3da, ubau, wippe, W_runter, nessiezunge
Global gwasser, gtex, gpos#=1, pointerJa, pointerNein, maus, mauszeit, zgfx, T1, T2, nalpha
Global flug1, flug2, rumpf, vogela, vogelb, vogelzeit, vogelricht#, absturz, warten
Global absturzzeit
;
Type party
	Field ax#,ay#,az#,vx#,vy#,vz#,gravity#,roll#,vroll#,life#,fadebias#,scalefactor#,scale#,ent
End Type
Type partikel
	Field ent,life#,vx#,vy#,vz#
End Type
; Highscoreliste
Global akt_Name$, iNeueZeile
Dim H_Name$(21), H_Datum$(21), H_Punkte(21), h_nam$(25)
; game-timing von mak
period = 1000/30 ; game FPS
time = MilliSecs() - period
; Graphikmodi
Dim Gfx3D(2,3) ; (redim)
; Sound
Global sfxWallhit, sfxbathit, sfxgolfball, sfxping1, sfxflash, sfxpipe, sfxmaus, sfxwater, sfxwater2
; Framecounter
Global Fc_framerate, Fc_counter, Fc_time
; Bahndaten fuer Blickzentrum usw.
Dim bahndaten#(17)
;
; generelle Ausgangswerte (nur bei Programmstart) --------------------------------------------------
High_laden()
MedienLaden()
Start()
; Hauptschleife ************************************************************************************
While weiter
	Repeat ; game speed (von mak)
		elapsed = MilliSecs() - time
	Until elapsed
	ticks = elapsed / period
	tween# = Float(elapsed Mod period) / Float(period)
	For flimit = 1 To ticks
		If flimit = ticks Then CaptureWorld
		time = time + period
		;
		; Ballstatus
		Select ballstatus
			Case 0 ; Titelbild anzeigen (bzw. Spielende)
				Titel1()
			Case 1 ; Schlagbereitschaft (Ball ruht)
				If camstatus = 0 Then
					Schlaeger()
					If MouseDown(1) Or KeyDown(28) Then
						abschlag = 1
						putzoom# = putzoom# + bbreit#
					Else
						If abschlag Then
							; neue Richtung Ball
							ang# = ATan2(EntityZ(ball)-EntityZ(putter),EntityX(ball)-EntityX(putter))
							xi# = Cos(ang#)
							zi# = Sin(ang#)
							; Tempo je nach Stellung des Tempo-Balkens
							speed# = speed# + breite / 50.0 ; Umsetzung power in Schlagstaerke
							TranslateEntity pfeil,0,-10,0 ; weg
							ballstatus = 6
						EndIf
					EndIf
				EndIf
			Case 2 ; Ball rollt
				If speed > 0 Then
					Ballbewegung()
				Else
					If training Then ; im Training
						If huepfen = 0 And EntityY(ball) > -0.5 Then ; kein Schlaeger ausserhalb Spielfeld
							speed# = 0
							ballstatus = 1 ; Schlagbereitschaft
						EndIf
					Else ; im Wettkampf
						If anzahl < 6 Then
							If huepfen = 0 And EntityY(ball) > -0.5 Then ; kein Schlaeger ausserhalb Spielfeld
								speed# = 0
								ballstatus = 1 ; Schlagbereitschaft
							EndIf
						Else ; maximale Schlagzahl erreicht
							anzahl = 7
							gesamt = gesamt + 1
							FlushKeys()
							FlushMouse()
							ballstatus = 4
						EndIf
					EndIf
				EndIf
; nur fuer Test:
;				If MouseHit(1) Or KeyHit(28) Then
;					speed# = 0 ; wieder Schlaeger zeigen (bei ruhendem Ball)
;					While MouseDown(1) Or KeyDown(57) Or KeyDown(28)
;					Wend
;					FlushMouse() : FlushKeys()
;					If huepfen > 0 Then Ballstart()
;				EndIf
; Ende fuer Test
			Case 3 ; eingelocht
				PositionEntity ball,0,-0.4,0
				Select bahn
					Case 11 ; Feuerwerk
						;SYNTAX: partikel(x,y,z,size,scalefactor,life#,fadebias#,vx#,vy#,vz#,roll#,gravity#)
						EntityTexture partikel(0,1.5,0,1,0.07,30,0.02,0,Rnd(0,0.5),Rnd(-1,1),Rnd(-5,5),-0.025),feuer
						EntityTexture partikel(0,1.5,0,1,0.07,25,0.02,Rnd(-0.5,0.5),Rnd(0,0.5),Rnd(-1,1),Rnd(-5,5),-0.027),rauch
						updatep() ; gehoert zu partikel()
					Case 18 ; Springbrunnen
						EntityTexture partikel(0,0.5,0,1,0.07,35,0.02,0,0.3,0,Rnd(-0.3,0.3),-0.025),spritzer
					Default ; bunte Kugeln
						If Rand(6) = 1 Then partikel2()
						updatep2() ; gehoert zu partikel2()
						If bahn = 16 Then ; Wippe auf Bahn 16 immer zurueckstellen (auch wenn auf Anhieb im Loch)
							If EntityPitch(wippe) > -20 Then TurnEntity wippe,-2,0,0 : W_runter = 0
						EndIf
				End Select
			Case 5 ; dreht im Loch
				yi# = (yi# + 60) Mod 360
				If xi > 0 Then xi = xi-0.002 ; xi# = 0.16
				PositionEntity ball,Cos(yi)*xi#,-0.4,Sin(yi)*xi#
				RotateEntity ball,0,0,0
				TurnEntity ball,zi# * speed# * drehen#,0,-xi# * speed# * drehen#
				RotateMesh ball,EntityPitch(ball),EntityYaw(ball),EntityRoll(ball)
				If xi < 0.1 Then
					mauskommt = mauskommt + 1 ; Maus-Steuerung (echte Maus)
					; und Ruhe...
					speed# = 0
					; Maus
					If mauskommt > mauswieoft Then
						If bahn = 11 Then
							If bahn <> 11 And bahn <> 18 Then partikel2() ; sonst erst bei Rand(7)=1
							ballstatus = 3
						Else ; nicht bei Vulkan-Bahn 11
							mauskommt = 0
							ShowEntity maus
							If soundon Then PlaySound sfxmaus
							mauszeit = MilliSecs() + 1650
							ballstatus = 9
						EndIf		
					Else
						If bahn <> 11 And bahn <> 18 Then partikel2()
						ballstatus = 3
					EndIf
				EndIf
				If bahn = 16 Then ; Wippe auf Bahn 16 immer zurueckstellen (auch wenn auf Anhieb im Loch)
					If EntityPitch(wippe) > -20 Then TurnEntity wippe,-2,0,0 : W_runter = 0
				EndIf
			Case 6 ; Ball wird geschlagen
				Schlagen()
			Case 9
				If MilliSecs() > mauszeit Then
					HideEntity maus
					mauszeit = 0
					If bahn <> 11 And bahn <> 18 Then partikel2()
					ballstatus = 3
				EndIf
			Case 11
				If MilliSecs() > wartezeit Then Ballstart()
		End Select
		;
		If ballstatus > 0 Then
			Tastatur() ; Tastatureingaben
			If W_runter = 0 Then
				If bahn = 16 Then ; Wippe auf Bahn 16 (immer) zurueckstellen
					If EntityPitch(wippe) > -20 Then TurnEntity wippe,-2,0,0
				EndIf
				If bahn = 18 Then ; Wasser, Fische und Hub auf Bahn 18
					; Wasser
					gpos# = gpos# + 0.001
					PositionTexture gtex,gpos#,1
					updatep() ; gehoert zu partikel()
					; Fische
					If fischauf = 0 Then
						TurnEntity fisch,0,0,-6
						If EntityRoll(fisch) > 110 And EntityRoll(fisch) < 120 Then
							EntityTexture partikel(EntityX(fisch)+1,EntityY(fisch)+0.8,EntityZ(fisch),0.3,-0.01,20,0.02,Rnd(-0.15,0.15),Rnd(0.3),Rnd(-1,1),Rnd(-20,20),-0.03),spritzer
						EndIf
						If EntityRoll(fisch) < 0 And EntityRoll(fisch) > -10 Then
							fischauf = 1
							fischneu = MilliSecs() + Rand(2000,10000)
						EndIf
					Else
						If MilliSecs() > fischneu Then
							PositionEntity fisch,Rnd(-1.5,1.5),-1,Rnd(-7.2,-8.9)
							fischauf = 0
							TurnEntity fisch,0,0,-20
						EndIf
					EndIf
					If fischauf2 = 0 Then
						TurnEntity fisch2,0,0,6
						If EntityRoll(fisch2) < -120 And EntityRoll(fisch2) > -130 Then
							EntityTexture partikel(EntityX(fisch2)-1,EntityY(fisch2)+0.8,EntityZ(fisch2),0.3,-0.01,20,0.02,Rnd(-0.15,0.15),Rnd(0.3),Rnd(-1,1),Rnd(-20,20),-0.03),spritzer
						EndIf
						If EntityRoll(fisch2) < 0 And EntityRoll(fisch2) > -10 Then
							fischauf2 = 1
							fischneu2 = MilliSecs() + Rand(2000,15000)
						EndIf
					Else
						If MilliSecs() > fischneu2 Then
							PositionEntity fisch2,Rnd(-1.5,1.5),-1,Rnd(-7.2,-8.9)
							fischauf2 = 0
							TurnEntity fisch2,0,0,20
						EndIf
					EndIf
					; Hub auf Bahn 18 (immer) zurueckstellen
					If EntityPitch(hub) > 0 Then TurnEntity hub,-2,0,0
				EndIf
			EndIf
		EndIf
		;	
		UpdateWorld()
	Next
	;
	RenderWorld tween#
	;
	; Texte und Bilder vor Flip ---------------------------------------------------
	Select ballstatus
		Case 0 ; Titelbild anzeigen bzw. Spielende
			Select punkt
				Case 0
					Titelbild()
				Case 1
					Hilfe0()
				Case 2
					Hilfe1()
				Case 3
					Hilfe2()
				Case 4
					Optionen()
				Case 5
					MLaden()
				Case 6
					High_plot2()
			End Select
		Case 1 ; Schlagstaerke anzeigen
			DrawBlock rahmen,25,scrH*2-27
			DrawBlockRect power,27,scrH*2-25,0,0,breite,15
		Case 2,6
			DrawBlock rahmen,25,scrH*2-27
		Case 3,5 ; eingelocht
			DrawBlock rahmen,25,scrH*2-27
			If training Then ; nur im Training
				If hinweise > 0 Then
					Schrift("Nochmal     : Mausklick links",20,unten-80)
					Schrift("Nchste Bahn: Leertaste, F4",20,unten-60)
				EndIf
				If MouseHit(1) Or KeyHit(1) Or KeyHit(28) Then
					If mauszeit Then HideEntity maus : mauszeit = 0 ; (echte) Maus weg
					Ballstart()
				EndIf
			Else ; Turnier
				If bahn < 18 Then
					If Hinweise > 0 Then Schrift("Nchste Bahn: Mausklick links",20,unten-60)
				Else
					If Hinweise > 0 Then Schrift("weiter: Mausklick links",20,unten-60)
				EndIf
				If MouseHit(1) Or KeyHit(1) Or KeyHit(28) Then
					If mauszeit Then HideEntity maus : mauszeit = 0 ; (echte) Maus weg
					;
					bahn = bahn + 1
					Bahnladen(1)
					If bahnok Then
						anzahl = 0
						Ballstart()
					Else					
						If gesamt < H_Punkte(20) Then ; Highscoreliste
							High_einordnen()
							Name_holen()
						Else ; Turnierende ohne neue Highscore
							DrawImage T2,25,unten-35
							Schrift("Schlge: "+Str$(anzahl),20,unten+20)
							Schrift("Gesamt: "+Str$(gesamt),20,unten+40)
							DrawBlock WEnde,scrW-175,scrH-31
							Flip
							i = 0
							While i = 0
								i = GetKey()
								If MouseHit(1) Then i = 1
							Wend
							FlushKeys()
							FlushMouse()
						EndIf
						Start()
					EndIf
				EndIf
			EndIf
		Case 4 ; Bild 'max. Schlagzahl erreicht' zeigen
			DrawBlock rahmen,25,scrH*2-27
			If hinweise > 0 Then
				If bahn < 18 Then
					Schrift("Nchste Bahn: Mausklick links.",20,unten-80)
				Else
					Schrift("weiter: Mausklick links",20,unten-60)
				EndIf
			EndIf				
			DrawBlock max6,scrW-206,scrH-50
			If MouseHit(1) Or KeyHit(1) Or KeyHit(28) Or KeyHit(57) Then
				bahn = bahn + 1
				Bahnladen(1)
				If bahnok Then
					anzahl = 0
					Ballstart()
				Else
					If gesamt < H_Punkte(20) Then ; Highscoreliste
						High_einordnen()
						Name_holen()
					EndIf
					Start()
				EndIf
			EndIf
		Case 12
			DrawBlock rahmen,25,scrH*2-27
			DrawBlockRect power,27,scrH*2-25,0,0,breite,15
			;
			wechselX = wechselX + wechselplus
			DrawBlock wechsel,wechselX,0
			If Abs(wechselX) >= scrW*2 Then
				FreeImage wechsel
				wechsel = 0
				ballstatus = 1
			EndIf
	End Select
	;
	; Hinweise ------------------------------------------------------------------------------
	If showfps Then Framecounter() ; fps
	If ballstatus > 0 Then
		If hinweise > 1 Then DrawImage maus2,20,30
		If hinweise > 0 Then ; Hinweise
			If camstatus = 1 Then
				If ballstatus = 1 Or ballstatus = 2 Or ballstatus = 6 Then Schrift("Maus bewegen...",20,unten-60)
			Else
				If ballstatus = 1 Then
					Schrift("Abschlag   : Maustaste links",20,unten-80)
					Schrift("Blickwinkel: Maustaste rechts",20,unten-60)
				EndIf
				If ballstatus = 2 Or ballstatus = 6 Then
					Schrift("Blickwinkel: Maustaste rechts",20,unten-60)
				EndIf
			EndIf
		EndIf
		If training Then
			DrawImage T1,25,unten-35
		Else
			DrawImage T2,25,unten-35
		EndIf
		Schrift("Schlge: "+Str$(anzahl),20,unten+20)
		If training = 0 Then Schrift("Gesamt: "+Str$(gesamt),20,unten+40) ; nur im Wettkampf
	EndIf
	;
;Schrift2(ggx,10,80)
	;
	Flip
	;
Wend
; Ende Hauptschleife *******************************************************************************
;
; Spielende
If aktW <> scrW*2 Or aktH <> scrH*2 Or aktD <> scrD Or aktsound <> soundon Or akthin <> hinweise Or aktshowfps <> showfps Or akttraining <> training Then
	Ini_schreiben()
Else
	If aktrueck <> rueckstellen Or aktblickwahl <> blickwahl Or aktmausdreh <> mausdreh Or aktmausempf# <> mausempf# Then Ini_schreiben()
EndIf
;
FreeImage speichern : FreeImage titel : FreeImage maus2 : FreeImage txtfrei : FreeImage rahmen
FreeImage pointer : FreeImage txtspeichern : FreeImage txtladen : FreeImage fntcouNew8f
FreeImage max6 : FreeImage Tasten : FreeImage T1 : FreeImage T2
FreeImage rahmen2 : FreeImage rahmen3 : FreeImage WEnde
FreeSound sfxWallhit : FreeSound sfxbathit : FreeSound sfxgolfball : FreeSound sfxwater2
FreeSound sfxping1 : FreeSound sfxflash : FreeSound sfxpipe : FreeSound sfxwater
ClearWorld()
End
;
;
; FUNKTIONEN
;
; -----------------------------------------------------------------------------------------------
; Ball abschlagen
; -----------------------------------------------------------------------------------------------
Function Schlagen()
	If putzoom# > 0.2 Then
		putzoom# = putzoom# - 0.5				
		; Schlaeger zum Ball bewegen
		putX# = Sin(putRotX) * putZoom#
		putZ# = putX# / Tan(putRotX#)
		PositionEntity putter,EntityX(ball) + putX#,EntityY(ball),EntityZ(ball) + putZ#
	Else
		If soundon Then PlaySound sfxpipe
		TranslateEntity putter,0,-10,0 ; weg
		If amAbschlag Then amAbschlag = 0 ; fuer: zurueck ins Titelbild
		abschlag = 0
		anzahl = anzahl + 1 ; Punkte
		gesamt = gesamt + 1
		; Ausgangswerte fuer Schlagstaerke einstellen
		breite = 0
		If bbreit# < 0 Then bbreit# = -bbreit# ; soll positiven Wert haben
		putzoom# = 0.5 ; Schlaeger spaeter wieder direkt an Ball heran
		ballstatus = 2
		FlushMouse()
		FlushKeys()
	EndIf
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Tastatureingaben und Hinweise (alles ausserhalb des Titelbildes)
; -----------------------------------------------------------------------------------------------
Function Tastatur()
	Local aend
	;----------
	If MouseHit(2) Then MouseXSpeed() : MouseYSpeed() : MouseZSpeed()
	If MouseDown(2) Then
		camstatus = 1 ; Maus verschiebt/dreht Kamera (nicht: Schlaeger)
		MoveEntity campivot,-MouseXSpeed() * mausempf#,0,0
		MoveEntity campivot,0,0,MouseYSpeed() * mausempf#
		TurnEntity campivot,0,mausdreh * MouseZSpeed(),0
		MoveMouse scrW,scrH ; center Maus
		aend = 1
	Else
		If camstatus = 1 Then camstatus = 0
	EndIf
	; Maus
	If mauszeit Then
		If MilliSecs() > mauszeit Then
			mauszeit = 0
			HideEntity maus
		EndIf
	Else
		If KeyHit(50) Then ; M = Maustaste...
			If bahn <> 11 Then ; nicht beim Vulkan...
				ShowEntity maus
				If soundon Then PlaySound sfxmaus
				mauszeit = MilliSecs() + 1650
			EndIf
		EndIf
	EndIf
	; Nessie
	If nessiezeit > 0 Then Nessiezeigen() ; Nessie kommt...
	If KeyHit(49) Then ; N = Nessie-Taste...
		nessieY# = -8
		nessieZ# = Rand(-50,100) ; +100 bis -50
		nessiedreh = 2
		PositionEntity nessiebauch,100,-2.5,nessieZ#
		PositionEntity nessiekopf,100,-2.5,nessieZ#
		ShowEntity nessiebauch
		ShowEntity nessiekopf
		ShowEntity nessiezunge			
		nessiezeit = 1
	EndIf
	; Moewe
	If absturzzeit > 0 Then	Moewezeigen()
	If KeyHit(47) Then absturzzeit = 1: HideEntity absturz ; V = Moewe eine Strecke fliegen lassen
	If KeyHit(48) Then ; B = Moewe abstuerzen lassen
		HideEntity flug1
		HideEntity flug2
		HideEntity rumpf
		absturzzeit = 3
		PositionEntity absturz,EntityX(ball),30,EntityZ(ball)
		ShowEntity absturz
	EndIf
	;
	If KeyHit(1) Then  ; ESC = zurueck zum Titelbild
		If ballstatus = 1 Then ; ins Titelbild, sofern nicht bereits im Titelbild...
			If amAbschlag Then ; Ball liegt am Abschlag -> zurueck ins Titelbild
				HideEntity ball
				Start()
			Else ; Ball liegt auf der Bahn -> zurueck zum Abschlag
				Ballstart()
			EndIf
		ElseIf ballstatus > 1 Then ; sofern im Spiel: Neubeginn am Abschlag
			If training Then ; im Training
				Ballstart()
			Else ; im Wettkampf
				If anzahl < 6 Then
					If ballstatus <> 3 And ballstatus <> 5 Then Ballstart() ; nur wenn nicht im Loch
				Else
					anzahl = 7
					gesamt = gesamt + 1
					FlushKeys()
					FlushMouse()
					ballstatus = 4
				EndIf
			EndIf
		EndIf
	EndIf
	;
	If KeyHit(59) Then ; F1 = Hilfe
		punkt = 1
		Repeat
			RenderWorld()
			Hilfe0()
			Flip
			If punkt = 0 Or punkt = 2 Then Exit
		Forever
		If punkt = 2 Then
			Repeat
				RenderWorld()
				Hilfe1()
				Flip
				If punkt = 0 Or punkt = 3 Then Exit
			Forever
			If punkt = 3 Then
				Repeat
					RenderWorld()
					Hilfe2()
					Flip
					If punkt = 0 Then Exit
				Forever
			EndIf
		EndIf
		While KeyDown(1) Or MouseDown(1)
		Wend
	EndIf
	;
	If KeyHit(60) Then ; F2 Blick auf Loch/Abschlag der Bahn
		blickwahl = blickwahl + 1
		If blickwahl > 1 Then blickwahl = 0
		Sicht()
	EndIf
	If KeyHit(61) Then ; F3 = vorherige Bahn
		If training Then ; nur im Training !!!
			bahn = bahn - 1
			If bahn < 1 Then bahn = 18
			BahnLaden(0)
			Ballstart()
		Else
			Meldung("Bahnwahl im Turnier nicht mglich")
		EndIf
	EndIf
	If KeyHit(62) Or KeyHit(57) Then ; F4 oder Leertaste = naechste Bahn
; nur fuer Test (Bahnwechsel auch im Turnier)
		If training Then ; nur im Training !!!
			bahn = bahn + 1
			If bahn > 18 Then bahn = 1
			BahnLaden(1)
			Ballstart()
		Else
			Meldung("Bahnwahl im Turnier nicht mglich")
		EndIf
; Ende fuer Test
	EndIf
	If KeyHit(63) Then ; F5 = Stop, von vorne (neuer Ball, gleiche Bahn)
		If training Then ; im Training
			Ballstart()
		Else ; im Wettkampf
			If anzahl < 6 Then
				Ballstart()
			Else
				anzahl = 7
				gesamt = gesamt + 1
				ballstatus = 4
			EndIf
		EndIf
	EndIf
	If KeyHit(64) Then MSpeichern() ; F6 = speichern (im Spiel) / laden (im Titelbild)
	If KeyHit(65) Then soundon = 1 - soundon ; F7 = Sound an/aus
	If KeyHit(66) Then Wettkampf()  ; F8 = umschalten Wettkampf / Training
	If KeyHit(67) Then SShot()      ; F9 = Screenshot
	If KeyHit(35) Or KeyHit(68) Then High_zeigen() ; H, F10 = Highscoreliste zeigen
	If KeyHit(87) Then hinweise = hinweise + 1 : If hinweise > 2 Then hinweise = 0 ; F11 = Hinweise an/aus
	If KeyHit(88) Then showfps = 1 - showfps ; F12 = Framecounter anzeigen
	; Blick veraendern ueber Tastatur
	; links/rechts
	If KeyDown(77) Or KeyDown(32) Then MoveEntity campivot,-0.5,0,0 : aend = 1 ;6 oder D
	If KeyDown(75) Or KeyDown(30) Then MoveEntity campivot,0.5,0,0 : aend = 1 ;4 oder A
	; rauf/runter
	If KeyDown(73) Or KeyDown(18) Then MoveEntity campivot,0,0.5,0 : aend = 1 ;9 oder E
	If (KeyDown(81) Or KeyDown(46)) And EntityY(campivot) > 1 Then MoveEntity campivot,0,-0.5,0 : aend = 1 ;3 oder C
	; vor, zurueck
	If KeyDown(72) Or KeyDown(17) Then MoveEntity campivot,0,0,-0.5 : aend = 1 ;8 oder W
	If KeyDown(80) Or KeyDown(45) Then MoveEntity campivot,0,0,0.5 : aend = 1 ;2 oder X
	;runterdrehen
	If KeyDown(71) Or KeyDown(16) Then TurnEntity camera,-1,0,0 : aend = 1 ;7 oder Q
	If KeyDown(79) Or KeyDown(44) Then TurnEntity camera,1,0,0 : aend = 1 ;1 oder Y
	; drehen
	If KeyDown(82) Or KeyDown(29) Then TurnEntity campivot,0,-2,0 : aend = 1 ;0 oder strg links
	If KeyDown(83) Or KeyDown(42) Then TurnEntity campivot,0,2,0 : aend = 1 ;, oder shift links
	;
	If aend = 1 Then
		PositionEntity camera,EntityX(campivot),EntityY(campivot),EntityZ(campivot)
		RotateEntity camera,EntityPitch#(camera),EntityYaw#(campivot),0 ;Z roll correction
		RotateEntity campivot,0,EntityYaw(campivot),0
	EndIf
	;
	If KeyHit(15) Or KeyHit(76) Or KeyHit(31) Then Sicht() ; Tab, S oder Ziffernblock 5 = Abschlagsblick
	;
	; Direktwahl der Bahnen
	If training Then
		For i = 2 To 13
			If KeyHit(i) Then
				altbahn = bahn
				bahn = i - 1
				If bahn <> altbahn Then ; nur wenn Bahn nicht bereits geladen ist
					If bahn > altbahn Then
						BahnLaden(1)
					Else
						Bahnladen(0)
					EndIf
					If bahnok Then
						Ballstart()
					Else
						Meldung("Fehler: Bahn "+Str$(bahn)+ " nicht gefunden.")
					EndIf
				EndIf
			EndIf
		Next
		j = 19
		For i = 22 To 27
			j = j - 1
			If KeyHit(i) Then
				altbahn = bahn
				bahn = j
				If bahn <> altbahn Then
					If bahn > altbahn Then
						BahnLaden(1)
					Else
						Bahnladen(0)
					EndIf
					If bahnok Then
						Ballstart()
					Else
						Meldung("Fehler: Bahn "+Str$(bahn)+ " nicht gefunden.")
					EndIf
				EndIf
			EndIf
		Next
	Else
		For i = 2 To 13
			If KeyHit(i) Then Meldung("Bahnwahl im Turnier nicht mglich")
		Next
		For i = 22 To 27
			If KeyHit(i) Then Meldung("Bahnwahl im Turnier nicht mglich")
		Next
	EndIf
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Grundeinstellungen bei Programmstart
; -----------------------------------------------------------------------------------------------
Function Start()
	For p.party = Each party
		FreeEntity p\ent
		Delete p
	Next
	For gp.partikel = Each partikel
		FreeEntity gp\ent
		Delete gp
	Next
	; Moewe zeigen
	vogelzeit = 1
	vogela = 1
	vogelb = 10
	vogelricht# = -0.3
	PositionEntity flug1,10,15,150 ; z = 150 bis -150
	PositionEntity flug2,10,15,150 ; x = -100 bis 150
	PositionEntity rumpf,10,15,150
	RotateEntity flug1,0,0,0
	RotateEntity flug2,0,0,0
	RotateEntity rumpf,0,0,0
	ShowEntity flug1
	ShowEntity flug2
	ShowEntity rumpf
	; Bahn
	bahn = 1
	BahnLaden(1)
	ballstatus = 0
	camstatus = 0
	putrotX = -180    ; vom Abschlag Richtung Loch bei Bahn 1 (geradeaus weg)
	TranslateEntity putter,0,-10,0 ; weg
	TranslateEntity pfeil,0,-10,0 ; weg
	anzahl = 0
	gesamt = 0
	punkt = 0
	MoveMouse scrW-30,scrH+180
	; Titelblick
	PositionEntity camera,-20,10,-20
	RotateEntity camera,15,-50,0
	PositionEntity campivot,EntityX(camera),EntityY(camera),EntityZ(camera)
	RotateEntity campivot,15,-50,0
	; Nessie zeigen
	nessiekommt = 1
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Wettkampf / Training
; -----------------------------------------------------------------------------------------------
Function Wettkampf()
	training = 1 - training
	gesamt = 0 ; Punkte von vorherigen Bahnen werden nicht uebernommen
	If training = 0 Then ; Wechsel auf Training ist mitten im Spiel moeglich
		anzahl = 0
		Meldung("Turnier Bahnen 1 bis 18") ; Turnier beginnt immer mit Bahn 1!
		If bahn > 1 Then
			bahn = 1
			Bahnladen(1)
		EndIf
	EndIf
	Ballstart()
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Neustart Ball
; -----------------------------------------------------------------------------------------------
Function BallStart()
	wartezeit = 0
	; 'echte' Maus weg
	HideEntity maus
	mauszeit = 0
	; seitlichen Anblick im Titelbild zurueckstellen
	If ballstatus = 0 Then Bahnladen(1)
	If rueckstellen Then Sicht() ; automatische Anfangssicht (abschaltbar)
	; aufraeumen
	For p.party = Each party
		FreeEntity p\ent
		Delete p
	Next
	For gp.partikel = Each partikel
		FreeEntity gp\ent
		Delete gp
	Next
	; Moewe weg
	If vogelzeit Then
		vogelzeit = 0
		HideEntity flug1
		HideEntity flug2
		HideEntity rumpf
	EndIf
	; Schlaege zaehlen
	If training Then
		gesamt = 0
		anzahl = 0
	EndIf
	; center Maus
	MoveMouse scrW,scrH
	breite = 4    ; Ausgangswert fuer Schlagstaerke
	If bbreit# < 0 Then bbreit# = -bbreit# ; soll positiven Wert haben
	HideEntity ball
	huepfen = 0
	bergneu# = 0	
	bergalt# = 0	
	bergdiff# = 0	
	speed# = 0
	xi# = 0
	yi# = 0
	zi# = 0
	x#  = bahndaten#(4) ; Abschlag
	y#  = 0
	z#  = bahndaten#(5)
	PositionEntity ball,x#,y#,z#
	amAbschlag = 1
	ShowEntity ball
	While KeyDown(28) Or MouseDown(1)
	Wend
	FlushMouse()
	FlushKeys()
	;
	Schlaeger()
	:
	If bahn = 16 Then ; Wippe auf Bahn 16 immer zurueckstellen (auch wenn auf Anhieb im Loch oder abgebrochen)
		RotateEntity wippe,-20,0,0
		W_runter = 0
	EndIf
	;
	; Bahnwechsel-Effekt
	If wechsel > 0 Then
		ballstatus = 12
	Else
		ballstatus = 1
	EndIf
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Ballphysik
; -----------------------------------------------------------------------------------------------
Function Ballbewegung()
	Local kollies
	;-------------
	; im Loch (vor! Kollisionen) ------------------
	If Abs(EntityX(ball)) < 0.18 And Abs(EntityZ(ball)) < 0.18 And (EntityY(ball) < 0 Or bahn = 11) And speed# < lochSpeed# Then
		If soundon Then PlaySound sfxgolfball
		; Ball im Loch noch etwas drehen lassen...
		xi# = 0.16
		ballstatus = 5
		Return
	EndIf
	;
	kollies = CountCollisions(ball)	; Kollisionen
	;
	If EntityCollided(ball,COLL_WALL45) Then ; Wandkollision 45 Grad
		If speed# > maxSpeed# Then
			huepfen = 1
			yi# = speed# * h_faktor#
			speed# = speed# * h_faktor2#
		Else
			ang# = -ang + 90
			xi# = Cos(ang)
			zi# = Sin(ang)
			speed# = speed# * 0.9 ; Energieverlust
			MoveEntity ball,xi# * speed#,yi#,zi# * speed#
		EndIf
		If soundon Then PlaySound sfxwallhit
	EndIf
	If EntityCollided(ball,COLL_WALL90) Then ; Wandkollision 90 Grad (seitlich in die Tiefe)
		If speed# > maxSpeed# Then
			huepfen = 1
			yi# = speed# * h_faktor#
			speed# = speed# * h_faktor2#
		Else
			ang# = -ang + 180
			xi# = Cos(ang)
			zi# = Sin(ang)
			speed# = speed# * 0.9 ; Energieverlust
			MoveEntity ball,xi# * speed#,yi#,zi# * speed#
		EndIf
		If soundon Then PlaySound sfxwallhit
	EndIf
	If EntityCollided(ball,COLL_WALL135) Then ; Wandkollision 135 Grad (seitlich in die Tiefe)
		If speed# > maxSpeed# Then
			huepfen = 1
			yi# = speed# * h_faktor#
			speed# = speed# * h_faktor2#
		Else
			ang# = -ang + 270
			xi# = Cos(ang)
			zi# = Sin(ang)
			speed# = speed# * 0.9 ; Energieverlust
			MoveEntity ball,xi# * speed#,yi#,zi# * speed#
		EndIf
		If soundon Then PlaySound sfxwallhit
	EndIf
	If EntityCollided(ball,COLL_WALL180) Then ; Wandkollision 180 Grad (vorne quer)
		If speed# > maxSpeed# Then
			huepfen = 1
			yi# = speed# * h_faktor#
			speed# = speed# * h_faktor2#
		Else
			ang# = -ang + 360
			xi# = Cos(ang)
			zi# = Sin(ang)
			speed# = speed# * 0.9 ; Energieverlust
			MoveEntity ball,xi# * speed#,yi#,zi# * speed#
		EndIf
		If soundon Then PlaySound sfxwallhit
	EndIf
	If EntityCollided(ball,COLL_KREIS) Then ; Kreiskollision innen
		If speed# > maxSpeed# Then
			huepfen = 1
			yi# = speed# * h_faktor#
			speed# = speed# * h_faktor2#
		Else
			a# = 90 + ATan2(-EntityZ(ball),-EntityX(ball))
			ang# = (-ang#+(a#*2) + 360) Mod 360
			xi# = Cos(ang)
			zi# = Sin(ang)
			speed# = speed# * 0.9 ; Energieverlust
			MoveEntity ball,xi# * speed#,yi#,zi# * speed#
		EndIf
		If soundon Then PlaySound sfxwallhit
	EndIf
	If EntityCollided(ball,COLL_POLLER) Then ; Pollerkollision
		If speed# > maxSpeed# Then
			huepfen = 1
			yi# = speed# * h_faktor#
			speed# = speed# * h_faktor2#
		Else
			Nx# = CollisionNX#(ball,kollies)
			Nz# = CollisionNZ#(ball,kollies)
			VdotN# = xi# * Nx# + 0 + zi# * Nz#
			NFx# = -2 * Nx# * VdotN#
			NFz# = -2 * Nz# * VdotN#
			xi# = xi# + NFx#
			zi# = zi# + NFz#
			ang#=ASin(zi#)
			speed# = speed# * 0.9 ; Energieverlust
			MoveEntity ball,xi# * speed#,yi#,zi# * speed#
		EndIf
		If soundon Then PlaySound sfxbathit
	EndIf
	;
	; huepfen -------------------------------------
	If huepfen > 0 Then
		yi# = yi# - gravity#
		If EntityCollided(ball,COLL_BODEN) Then ; Bodenkollision innerhalb
			yi# = Abs(yi# * 0.5)
			speed# = speed# * 0.9
			huepfen = huepfen + 1
			If huepfen > 5 Then huepfen = 0 : yi# = -gravity#
			If soundon Then PlaySound sfxflash
		EndIf
		If EntityY(ball) < -0.4 Then ; Bodenkollision ausserhalb
			yi# = Abs(yi# * 0.5)
			speed# = speed# * 0.8
			huepfen = huepfen + 1
			If huepfen > 5 Then huepfen = 0 : yi# = -gravity#
;			If soundon Then PlaySound ?
		EndIf
	Else
		If EntityCollided(ball,COLL_BODEN) Then ; Bodenkollision
			yi# = 0
			; nach oben bzw. zurueckrollen
			If EntityY(ball) > 0.06 Then
				; Hoehenunterschied
				bergalt# = bergneu#
				bergneu# = EntityY(ball)
				bergdiff# = 0.5 * (bergneu# - bergalt#)
				speed# = speed# - bergdiff# ; rauf = Abzug, runter = Addition 
				If speed# < 0.005 Then ; wie Kollision
					If bahn = 11 Then ; Vulkan (wie Kreis)
						a# = 90 + ATan2(-EntityZ(ball),-EntityX(ball))
						ang# = (-ang#+(a#*2) + 360) Mod 360
						xi# = Cos(ang)
						zi# = Sin(ang)
					Else ; wie Wand-180
						ang# = -ang + 360
						xi# = Cos(ang)
						zi# = Sin(ang)
					EndIf
					speed# = 0.007 ; wieder positiv u. groesser als 'Stoppwert' weiter unten
				EndIf
				; Wippe auf Bahn 16
				If bahn = 16 And W_runter = 0 Then
					If EntityY(ball) > 1 Then W_runter = 1
				EndIf
			Else
				If bergneu <> 0 Then bergneu# = 0
			EndIf
		Else
			yi# = yi# - gravity#
			If yi# < -0.4 Then huepfen = 3 ; huepfen nach dem senkrechten Fallen
		EndIf
	EndIf
	; Wippe auf Bahn 16 ---------------------------
	If bahn = 16 Then
		If W_runter And EntityPitch(wippe) < 20 Then
			TurnEntity wippe,2,0,0
		Else
			If EntityY(ball) < 0.1 Then W_runter = 0
		EndIf
		While MeshesIntersect(ball,wippe)
			MoveEntity ball,0,0.3,0
		Wend
	EndIf
	; Schleuder auf Bahn 18 -----------------------
	If bahn = 18 Then
		; im Wasser abbremsen
		If EntityY(ball) < 0.9 And EntityZ(ball) < -7.5 And EntityZ(ball) > -8.5 Then
			If speed# > 0.9 Then
				If soundon Then PlaySound sfxwater
			Else
				If soundon Then PlaySound sfxwater2
			EndIf
			If speed# > 2 Then speed# = 2
			For i = 1 To 10
				EntityTexture partikel(EntityX(ball),-0.1,EntityZ(ball),speed#,-0.01,30,0.02,Rnd(-0.15,0.15),Rnd(0.3),Rnd(-1,1),Rnd(-20,20),-0.03),spritzer
			Next
			yi# = -1
			ballstatus = 11
			wartezeit = MilliSecs() + speed# * 500
			speed# = 0
		EndIf
		; hochschleudern
		If EntityCollided(ball,COLL_HUB) Then
			W_runter = 0
			TurnEntity hub,46,0,0
			huepfen = 1
			speed# = 0.5
			yi# = Rnd(0.4,0.6) ; 0.5
			xi# =Rnd(-0.05,0.05) ; 0
		EndIf
	EndIf
	; Balltempo (langsamer werden (Reibung)) ------
	If Abs(speed#) < 0.005 Then
		speed# = 0
	Else
		speed# = speed# / rollwiderstand#
	EndIf
	;
	; Ballbewegung (nicht: Moveentity) ------------
	PositionEntity ball,EntityX(ball)+xi# * speed#,EntityY(ball)+yi#,EntityZ(ball)+zi# * speed#
	;
	; Ball drehen ---------------------------------
	RotateEntity ball,0,0,0 ;reset turnentity
	TurnEntity ball,zi# * speed# * drehen#,0,-xi# * speed# * drehen# ;turn it how you want
	RotateMesh ball,EntityPitch(ball),EntityYaw(ball),EntityRoll(ball) ;reset the ball's coordinate system!
	;
	; Vogelabsturz ausloesen
	If EntityY(ball) > 6 Then
		HideEntity flug1
		HideEntity flug2
		HideEntity rumpf
		absturzzeit = 3
		PositionEntity absturz,EntityX(ball),20,EntityZ(ball)
		ShowEntity absturz
	EndIf
	;
	; ausserhalb ----------------------------------
	If EntityY(ball) < -3 Then Ballstart()
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Schlaeger bewegen und Ball abschlagen mit der Maus oder der Tastatur
; -----------------------------------------------------------------------------------------------
Function Schlaeger()
	Local i, cx#, cy#, cz#
	;----------------------
	; Schlaeger drehen u. zoomen (putZoom# = heran-/wegzoomen)
;	putZoom# = putZoom# + Float#(-MouseZSpeed() * 0.1) ; Mausrad wird jetzt zum Bild drehen verwendet
	If KeyDown(208) Then putZoom# = putZoom# + 0.025
	If KeyDown(200) Then putZoom# = putZoom# - 0.025
	If putzoom# < 0.5 Then putzoom# = 0.5
	If putzoom# > 2.0 Then putzoom# = 2.0
	;
	breite = (putzoom#-0.5) * 100.0
	If breite >= 150 Or breite <= 0 Then bbreit# = -bbreit#
	;
	putrotX# = putrotX# + MouseXSpeed() ; putRotX = Horizontale Putter-Rotation
	If KeyDown(205) Then putrotX# = putrotX# + 2
	If KeyDown(203) Then putrotX# = putrotX# - 2
	If putRotX# = 0 Then putRotX# = 1 ; sonst verschwunden! (putZ# = Cos(y#) * putZoom)
	MoveMouse scrW, scrH ; recenter Maus
	; Schlaeger bewegen
	putX# = Sin(putRotX) * putZoom#
	putZ# = putX# / Tan(putRotX#)
	PositionEntity putter,EntityX(ball) + putX#,EntityY(ball),EntityZ(ball) + putZ#
	PointEntity putter,ball
	; Pfeil anzeigen
	pfeilX# = Sin(putRotX) * 0.15 ; * putZoom#
	pfeilZ# = pfeilX# / Tan(putRotX#)
	PositionEntity pfeil,EntityX(ball) - pfeilX#,EntityY(ball),EntityZ(ball) - pfeilZ#
	TranslateEntity pfeil,0,-0.03,0
	PointEntity pfeil,putter
	; Pfeil anheben bei Steigung/Hindernis
	i = 0
	Select bahn
		Case 1
			While MeshesIntersect(pfeil,poller) Or MeshesIntersect(pfeil,poller2) Or MeshesIntersect(pfeil,poller3)
				i = i + 5
				TurnEntity pfeil,i,0,0
				If i > 85 Then Exit ; Notausgang
			Wend
		Case 3,6,9,10,11
			While MeshesIntersect(pfeil,boden)
				i = i + 5
				TurnEntity pfeil,i,0,0
				If i > 85 Then Exit
			Wend
		Case 13,15
			While MeshesIntersect(pfeil,poller) Or MeshesIntersect(pfeil,poller2)
				i = i + 5
				TurnEntity pfeil,i,0,0
				If i > 85 Then Exit
			Wend
		Case 16
			While MeshesIntersect(pfeil,wippe) Or MeshesIntersect(pfeil,poller) Or MeshesIntersect(pfeil,poller2)
				i = i + 5
				TurnEntity pfeil,i,0,0
				If i > 85 Then Exit
			Wend
	End Select
	;
	ScaleEntity pfeil,1,1,putzoom# ; Pfeillaenge
	EntityColor pfeil,putzoom# * 100 + 55,255 - putzoom# * 100,0 ; Pfeilfarbe gruen nach rot
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Partikel von Rob Cummings
; -----------------------------------------------------------------------------------------------
Function partikel(ax#,ay#,az#,scale#,scalefactor#,life#,fadebias#,vx#,vy#,vz#,vroll#,gravity#)
	p.party = New party
	p\ent = CreateSprite()
	EntityBlend p\ent,3
	p\life = life
	p\vx = vx
	p\vy = vy
	p\gravity = gravity
	p\fadebias = fadebias
	p\vroll = vroll
	p\scalefactor = scalefactor
	p\scale = scale
	ScaleSprite p\ent,scale,scale
	PositionEntity p\ent,ax#,ay#,az#
	Return p\ent
End Function

Function updatep()
	For p.party = Each party
		If p\life = 0
			FreeEntity p\ent
			Delete p
		Else
			p\life = p\life - 1
			p\vy = p\vy + p\gravity
			p\roll = p\roll + p\vroll
			p\scale = p\scale + p\scalefactor
			If p\scale < 0 Then p\scale = 0
			ScaleSprite p\ent,p\scale,p\scale
			EntityAlpha p\ent,p\life*p\fadebias
			RotateSprite p\ent,p\roll
			MoveEntity p\ent,p\vx,p\vy,p\vz
		EndIf
	Next
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Variante von Rob Cumming's Partikel
; -----------------------------------------------------------------------------------------------
Function partikel2()
	Local i
	;----------
	gp.partikel = New partikel
	gp\ent = CopyEntity(powerup)
	i = Rand(6)
	Select i
		Case 1
			EntityColor gp\ent,255,0,0
		Case 2
			EntityColor gp\ent,0,255,0
		Case 3
			EntityColor gp\ent,0,0,255
		Case 4
			EntityColor gp\ent,255,255,255
		Case 5
			EntityColor gp\ent,255,255,0
		Case 6
			EntityColor gp\ent,255,0,255
	End Select
	gp\life = 65
	gp\vz = -0.08
	If bahn = 11 Then PositionEntity gp\ent,0,1.4,0
	Return gp\ent
End Function

Function updatep2() ; gehoert zu partikel2()
	For gp.partikel = Each partikel
		If gp\life = 0
			FreeEntity gp\ent
			Delete gp
		Else
			gp\life = gp\life - 1
			EntityAlpha gp\ent,gp\life*0.03
			gp\vx = gp\vx+10 : If gp\vx > 360 Then gp\vx = 0
			gp\vy = gp\vy+10 : If gp\vy > 360 Then gp\vy = 0 
			MoveEntity gp\ent,0.2*Cos(gp\vx),0.2*Sin(gp\vy),gp\vz
		EndIf
	Next
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Anzeige der Bilderzahl (frames)
; -----------------------------------------------------------------------------------------------
Function Framecounter()
	Fc_counter = Fc_counter + 1
	If Fc_time = 0 Then Fc_time = MilliSecs()
	If Fc_time + 1001 < MilliSecs() Then
		Fc_framerate = Fc_counter
		Fc_counter = 0
		Fc_time = MilliSecs()
	EndIf
	Schrift("fps: "+Fc_framerate,20,10)
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Diese Funktion erstellt durchnummerierte Screenshots im Verzeichnis der Programmdatei
; -----------------------------------------------------------------------------------------------
Function SShot()
	Local ii, D_Name$
	;-----------------
	ii = 0
	Repeat
		ii = ii + 1
		D_Name$ = "Screenshot" + Str$(ii) + ".bmp"
	Until FileType(D_Name$) = 0
	SaveBuffer(FrontBuffer(),D_Name$)
	Meldung("Screenshot unter " + D_Name$)
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Gespeichertes Spiel laden
; -----------------------------------------------------------------------------------------------
Function MLaden()
	Local i, mx, my, mz, offsetX, offsetY, wahl, H_Datei, ok, wp#
	Local pivotX#, pivotY#, pivotZ#, pivotYaw#, camPitch#, altX, altY
	;----------------------------------------------------------------
	; offset beruecksichtigen
	offsetX = scrW - 512
	offsetY = scrH - 180
	If tasteX = 0 Then tasteX = 250	
	If tasteY = 0 Then tasteY = 400	
	; und anzeigen...
	mx = MouseX()
	my = MouseY()
	mz = MouseHit(1)
	If KeyHit(28) Then mz=1
	; Begrenzung
	If mx < offsetX Then mx = offsetX
	If mx > offsetX+1010 Then mx = offsetX+1009
	If my < offsetY Then my = offsetY
	If my > offsetY+340 Then my = offsetY+339
	; Tastatur
	If KeyHit(205) Then ; rechts
		If tasteY = offsetY + 336 And tasteX = offsetX + 512 Then
		Else
			tasteX = tasteX + 300
			If tasteX > offsetX + 900 Then tasteX = offsetX + 250
			MoveMouse tasteX,tasteY
		EndIf
	EndIf
	If KeyHit(203) Then ; links
		If tasteY = offsetY + 336 And tasteX = offsetX + 512 Then
		Else
			tasteX = tasteX - 300
			If tasteX < offsetX + 200 Then tasteX = offsetX + 850
			MoveMouse tasteX,tasteY
		EndIf
	EndIf
	If KeyHit(208) Then ; runter
		If tasteY = offsetY + 200 Then
			tasteY = offsetY + 295
		ElseIf tasteY = offsetY + 295 Then
			tasteY = offsetY + 336
			tasteX = offsetX + 512
		ElseIf tasteY = offsetY + 336 Then
			tasteY = offsetY + 200
		Else
			tasteY = offsetY + 200
		EndIf		
		MoveMouse tasteX,tasteY
	EndIf
	If KeyHit(200) Then ; hoch
		If tasteY = offsetY + 200 Then
			tasteY = offsetY + 336
			tasteX = offsetX + 512
		ElseIf tasteY = offsetY + 295 Then
			tasteY = offsetY + 200
		ElseIf tasteY = offsetY + 336 Then
			tasteY = offsetY + 295
		Else
			tasteY = offsetY + 200
		EndIf
		MoveMouse tasteX,tasteY
	EndIf
	;	
	DrawBlock speichern,offsetX,offsetY
	DrawBlock txtladen,scrW-91,offsetY+10
	If bild1da Then
		DrawBlock bild1,offsetX+64,offsetY+84
		DrawBlock txtfrei,offsetX+64+50,offsetY+282
	EndIf
	If bild2da Then
		DrawBlock bild2,offsetX+384,offsetY+84
		DrawBlock txtfrei,offsetX+384+50,offsetY+282
	EndIf
	If bild3da Then
		DrawBlock bild3,offsetX+704,offsetY+84
		DrawBlock txtfrei,offsetX+704+50,offsetY+282
	EndIf
	; Auswahl
	Color 0,255,0
	If mx-offsetX > 63 And mx-offsetX < 321 Then
		If bild1da Then
			If my-offsetY > 83 And my-offsetY < 275 Then
				Rect offsetX+62,offsetY+81,260,196,0
				If mz Then wahl = 1
			EndIf
			If my-offsetY > 274 And my-offsetY < 304 Then
				Rect offsetX+62,offsetY+280,260,25,0
				If mz Then wahl = 4
			EndIf
		EndIf
	ElseIf mx-offsetX > 383 And mx-offsetX < 639 Then
		If bild2da Then
			If my-offsetY > 83 And my-offsetY < 275 Then
				Rect offsetX+381,offsetY+81,260,196,0
				If mz Then wahl = 2
			EndIf
			If my-offsetY > 274 And my-offsetY < 304 Then
				Rect offsetX+381,offsetY+280,260,25,0
				If mz Then wahl = 5
			EndIf
		EndIf
	ElseIf mx-offsetX > 702 And mx-offsetX < 959 Then
		If bild3da Then
			If my-offsetY > 83 And my-offsetY < 275 Then
				Rect offsetX+701,offsetY+81,260,196,0
				If mz Then wahl = 3
			EndIf
			If my-offsetY > 274 And my-offsetY < 304 Then
				Rect offsetX+701,offsetY+280,260,25,0
				If mz Then wahl = 6
			EndIf
		EndIf
	EndIf
	; Ausstieg		
	If KeyHit(1) Then
		If bild1da Then FreeImage bild1 : bild1 = 0
		If bild2da Then FreeImage bild2 : bild2 = 0
		If bild3da Then FreeImage bild3 : bild3 = 0
		punkt = 0
	EndIf
	If mx-offsetX > 440 And mx-offsetX < 580 And my-offsetY > 330 And my-offsetY < 352 Then
		Rect offsetX+440,offsetY+328,145,26,0
		If mz = 1 Then
			If bild1da Then FreeImage bild1 : bild1 = 0
			If bild2da Then FreeImage bild2 : bild2 = 0
			If bild3da Then FreeImage bild3 : bild3 = 0
			punkt = 0
		EndIf
	EndIf
	;		
	DrawImage pointer,mx,my
	;
	; Auswahl wurde getroffen: loeschen...
	If wahl > 3 Then
		altX = tasteX
		altY = tasteY		
		FlushKeys()
		FlushMouse()
		; Sicherheitsabfrage
		ok = 0
		i = 0
		If wahl = 4 Then
			MoveMouse offsetX+260,offsetY+182
			tasteX = offsetX+260
			tasteY = offsetY+182
		ElseIf wahl = 5 Then
			MoveMouse offsetX+580,offsetY+182
			tasteX = offsetX+580
			tasteY = offsetY+182
		ElseIf wahl = 6 Then
			MoveMouse offsetX+902,offsetY+182
			tasteX = offsetX+902
			tasteY = offsetY+182
		EndIf		
		While i = 0
			mx = MouseX()
			my = MouseY()
			mz = MouseHit(1)
			If KeyHit(28) Then mz = 1 ; Return
			; Begrenzung
			If mx < offsetX Then mx = offsetX
			If mx > offsetX+1010 Then mx = offsetX+1009
			If my < offsetY Then my = offsetY
			If my > offsetY+340 Then my = offsetY+339
			;
			If KeyHit(203) Then ; links
				If tasteX = offsetX+260 Then tasteX = offsetX+280
				If tasteX = offsetX+280 Then tasteX = offsetX+260
				If tasteX = offsetX+580 Then tasteX = offsetX+600
				If tasteX = offsetX+600 Then tasteX = offsetX+580
				If tasteX = offsetX+902 Then tasteX = offsetX+922
				If tasteX = offsetX+922 Then tasteX = offsetX+902
				MoveMouse tasteX,tasteY
			EndIf
			If KeyHit(205) Then ; rechts
				If tasteX = offsetX+280 Then tasteX = offsetX+260
				If tasteX = offsetX+260 Then tasteX = offsetX+280
				If tasteX = offsetX+600 Then tasteX = offsetX+580
				If tasteX = offsetX+580 Then tasteX = offsetX+600
				If tasteX = offsetX+922 Then tasteX = offsetX+902
				If tasteX = offsetX+902 Then tasteX = offsetX+922
				MoveMouse tasteX,tasteY
			EndIf
			;
			DrawBlock speichern,offsetX,offsetY
			DrawBlock txtladen,scrW-91,offsetY+10
			If bild1da Then
				DrawBlock bild1,offsetX+64,offsetY+84
				DrawBlock txtfrei,offsetX+64+50,offsetY+282
			EndIf
			If bild2da Then
				DrawBlock bild2,offsetX+384,offsetY+84
				DrawBlock txtfrei,offsetX+384+50,offsetY+282
			EndIf
			If bild3da Then
				DrawBlock bild3,offsetX+704,offsetY+84
				DrawBlock txtfrei,offsetX+704+50,offsetY+282
			EndIf
			Select wahl
				Case 4
					Schrift("Wirklich lschen (J/N)?",offsetX+71,offsetY+174)
				Case 5
					Schrift("Wirklich lschen (J/N)?",offsetX+391,offsetY+174)
				Case 6
					Schrift("Wirklich lschen (J/N)?",offsetX+711,offsetY+174)
			End Select
			If my > offsetY+174 And my < offsetY+190 Then
				; 1
				If mx > offsetX+250 And mx < offsetX+272 Then
					DrawImage pointerJa,mx,my
					If mz Then ok = 1 : Exit
				EndIf
				If mx > offsetX+271 And mx < offsetX+292 Then
					DrawImage pointerNein,mx,my
					If mz Then ok = 0 : Exit
				EndIf
				; 2
				If mx > offsetX+570 And mx < offsetX+592 Then
					DrawImage pointerJa,mx,my
					If mz Then ok = 1 : Exit
				EndIf
				If mx > offsetX+591 And mx < offsetX+612 Then
					DrawImage pointerNein,mx,my
					If mz Then ok = 0 : Exit
				EndIf
				; 3
				If mx > offsetX+891 And mx < offsetX+911 Then
					DrawImage pointerJa,mx,my
					If mz Then ok = 1 : Exit
				EndIf
				If mx > offsetX+911 And mx < offsetX+930 Then
					DrawImage pointerNein,mx,my
					If mz Then ok = 0 : Exit
				EndIf
			EndIf
			i = GetKey()
			If i = 74 Or i = 106 Then ok = 1 : Exit
			If i = 30 Or i = 31 Then i = 0 ; Pfeil rechts/links
			DrawImage pointer,mx,my
			Flip
		Wend
		tasteX = altX
		tasteY = altY
		FlushKeys()
		FlushMouse()
		If ok Then
			If FileType("Save\Speicher"+Str$(wahl-3)+".bmp") = 1 Then
				DeleteFile "Save\Speicher"+Str$(wahl-3)+".bmp"
			EndIf
			If FileType("Save\Speicher"+Str$(wahl-3)+".dat") = 1 Then
				DeleteFile "Save\Speicher"+Str$(wahl-3)+".dat"
			EndIf
			Select wahl
				Case 4
					bild1da = 0 : FreeImage bild1
				Case 5
					bild2da = 0 : FreeImage bild2
				Case 6
					bild3da = 0 : FreeImage bild3
			End Select
		EndIf
	EndIf
	; Auswahl wurde getroffen: laden...
	If wahl > 0 And wahl < 4 Then
		H_Datei = ReadFile("Save\Speicher"+Str$(wahl)+".dat")
		If H_Datei Then
			bahn = ReadInt(H_Datei)
			blickwahl = ReadInt(H_Datei)
			BahnLaden(2)
			pivotX# = ReadFloat(H_Datei)
			pivotY# = ReadFloat(H_Datei)
			pivotZ# = ReadFloat(H_Datei)
			camPitch# = ReadFloat(H_Datei)
			pivotyaw# = ReadFloat(H_Datei)
			ang# = ReadFloat(H_Datei)
			xi# = ReadFloat(H_Datei)
			yi# = ReadFloat(H_Datei)
			zi# = ReadFloat(H_Datei)
			a# = ReadFloat(H_Datei)
			x# = ReadFloat(H_Datei)
			y# = ReadFloat(H_Datei)
			z# = ReadFloat(H_Datei)
			speed# = ReadFloat(H_Datei)
			putX# = ReadFloat(H_Datei)
			putZ# = ReadFloat(H_Datei)
			putZoom# = ReadFloat(H_Datei)
			putRotX# = ReadFloat(H_Datei)
			pfeilX# = ReadFloat(H_Datei)
			pfeilZ# = ReadFloat(H_Datei)
			bergalt# = ReadFloat(H_Datei)
			bergneu# = ReadFloat(H_Datei)
			bergdiff# = ReadFloat(H_Datei)
			wp# =  ReadFloat(H_Datei)
			mausempf# =  ReadFloat(H_Datei)
			mausdreh = ReadInt(H_Datei)
			w_runter = ReadInt(H_Datei)
			breite = ReadInt(H_Datei)
			ballstatus = ReadInt(H_Datei)
			camstatus = ReadInt(H_Datei)
			huepfen = ReadInt(H_Datei)
			showfps = ReadInt(H_Datei)
			anzahl = ReadInt(H_Datei)
			gesamt = ReadInt(H_Datei)
			hinweise = ReadInt(H_Datei)
			soundon = ReadInt(H_Datei)
			abschlag = ReadInt(H_Datei)
			amAbschlag = ReadInt(H_Datei)
			training = ReadInt(H_Datei)
			rueckstellen = ReadInt(H_Datei)
			CloseFile(H_Datei)
			;
			; Partikel weg
			For gp.partikel = Each partikel
				FreeEntity gp\ent
				Delete gp
			Next
			PositionEntity camera,pivotX#,pivotY#,pivotZ#
			RotateEntity camera,camPitch#,pivotyaw#,0
			RotateEntity campivot,0,pivotyaw#,0
			; ggf. Putter weg
			If ballstatus <> 1 Then
				TranslateEntity putter,0,-10,0 ; weg
				TranslateEntity pfeil,0,-10,0 ; weg
			EndIf
			; Ball
			PositionEntity ball,x#,y#+0.05,z# ; etwas hoeher, faellt sonst manchmal durch die Bahn
			If bahn = 16 Then ; Wippe
				While MeshesIntersect(ball,wippe)
					MoveEntity ball,0,0.3,0
				Wend
			EndIf
			If bahn = 16 Then ; Wippe
				RotateEntity wippe,wp#,0,0
				If EntityY(ball) > 0.5 Then
					If speed# < 0 Then
						speed# = speed# - 0.05
					Else
						speed# = speed# + 0.05
					EndIf
				EndIf 
			EndIf
			ShowEntity ball
			; Laden beenden
			If bild1da Then FreeImage bild1 : bild1 = 0
			If bild2da Then FreeImage bild2 : bild2 = 0
			If bild3da Then FreeImage bild3 : bild3 = 0
			punkt = 0
		Else
			Meldung("Fehler: Datei 'Save\Speicher"+Str$(wahl)+".dat' nicht gefunden.")
		EndIf
	EndIf
	;
	If KeyHit(67) Then SShot() ; F9 = Screenshot
	;
	If punkt = 0 Then
		MoveMouse scrW-30,scrH+180
		While KeyDown(1) Or MouseDown(1)
		Wend
		FlushMouse()
		FlushKeys()
	EndIf
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Spiel speichern
; -----------------------------------------------------------------------------------------------
Function MSpeichern()
	Local i, mx, my, mz, offsetX, offsetY, wahl, bild, mxalt, myalt, H_Datei, wp#
	Local bild1, bild2, bild3, bild1da, bild2da, bild3da, sx#, sy#, sz#, ok1, ok2, ok3
	;---------------------------------------------------------------------------------
	; alte Position speichern!
	mxalt = MouseX()
	myalt = MouseY()
	offsetX = scrW - 512
	offsetY = scrH - 180
	If tasteX = 0 Then tasteX = 250	
	If tasteY = 0 Then tasteY = 400	
	; Verzeichnis da?
	i = FileType("Save")
	If i <> 2 Then CreateDir "Save" ; directory not found, Verzeichnis wird angelegt
	; 3 Speicher-Bilder laden
	Bild1 = LoadImage("Save\Speicher1.bmp") : If Bild1 > 0 Then bild1da = 1
	Bild2 = LoadImage("Save\Speicher2.bmp") : If Bild2 > 0 Then bild2da = 1
	Bild3 = LoadImage("Save\Speicher3.bmp") : If Bild3 > 0 Then bild3da = 1
	FlushMouse()
	FlushKeys()
	Repeat
		mx = MouseX()
		my = MouseY()
		mz = MouseHit(1)
		If KeyHit(28) Then mz = 1
		; Begrenzung
		If mx < offsetX Then mx = offsetX
		If mx > offsetX+1010 Then mx = offsetX+1009
		If my < offsetY Then my = offsetY
		If my > offsetY+340 Then my = offsetY+339
		; Tastatur
		If KeyHit(205) Then ; rechts
			If tasteY = offsetY + 336 And tasteX = offsetX + 512 Then
			Else
				tasteX = tasteX + 300
				If tasteX > offsetX + 900 Then tasteX = offsetX + 250
				MoveMouse tasteX,tasteY
			EndIf
		EndIf
		If KeyHit(203) Then ; links
			If tasteY = offsetY + 336 And tasteX = offsetX + 512 Then
			Else
				tasteX = tasteX - 300
				If tasteX < offsetX + 200 Then tasteX = offsetX + 850
				MoveMouse tasteX,tasteY
			EndIf
		EndIf
		If KeyHit(208) Then ; runter
			If tasteY = offsetY + 200 Then
				tasteY = offsetY + 336
				tasteX = offsetX + 512
			Else
				tasteY = offsetY + 200
			EndIf		
			MoveMouse tasteX,tasteY
		EndIf
		If KeyHit(200) Then ; hoch
			If tasteY = offsetY + 200 Then
				tasteY = offsetY + 336
				tasteX = offsetX + 512
			Else
				tasteY = offsetY + 200
			EndIf
			MoveMouse tasteX,tasteY
		EndIf
		;
		RenderWorld
		DrawBlock speichern,offsetX,offsetY
		DrawBlock txtspeichern,scrW-171,offsetY+10
		If bild1da Then DrawBlock bild1,offsetX+64,offsetY+84
		If bild2da Then DrawBlock bild2,offsetX+384,offsetY+84
		If bild3da Then DrawBlock bild3,offsetX+704,offsetY+84
		If my-offsetY > 83 And my-offsetY < 275 Then
			If mx-offsetX > 63 And mx-offsetX < 321 Then
				Color 255,0,0
				Rect offsetX+62,offsetY+81,260,196,0
				If mz Then wahl = 1
			ElseIf mx-offsetX > 383 And mx-offsetX < 639 Then
				Color 255,0,0
				Rect offsetX+382,scrH-180+81,260,196,0
				If mz Then wahl = 2
			ElseIf mx-offsetX > 702 And mx-offsetX < 959 Then
				Color 255,0,0
				Rect offsetX+701,offsetY+81,260,196,0
				If mz Then wahl = 3
			EndIf
		EndIf
		; Ausstieg
		If KeyHit(1) Then Exit
		If mx-offsetX > 440 And mx-offsetX < 580 And my-offsetY > 330 And my-offsetY < 352 Then
			Rect offsetX+440,offsetY+328,145,26,0
			If mz = 1 Then Exit
		EndIf
		; Hinweis nach Speicherung
		If ok1 > 0 Then
			If MilliSecs() < ok1 Then
				Schrift("Spiel wurde gespeichert.",offsetX+71,offsetY+174)
			Else
				ok1 = 0
			EndIf
		EndIf
		If ok2 > 0 Then
			If MilliSecs() < ok2 Then
				Schrift("Spiel wurde gespeichert.",offsetX+391,offsetY+174)
			Else
				ok2 = 0
			EndIf
		EndIf
		If ok3 > 0 Then
			If MilliSecs() < ok3 Then
				Schrift("Spiel wurde gespeichert.",offsetX+711,offsetY+174)
			Else
				ok3 = 0
			EndIf
		EndIf
		;
		DrawImage pointer,mx,my
		Flip
		; Auswahl wurde getroffen
		If wahl > 0 Then
			; Bild speichern
			Color 255,255,255
			CameraZoom camera,0.25
			RenderWorld()
			Bild = CreateImage(256,192)				
;			CopyRect 384,288,256,192,0,0,BackBuffer(),ImageBuffer(Bild)
			CopyRect ((scrW*2)-256)/2,((scrH*2)-192)/2,256,192,0,0,BackBuffer(),ImageBuffer(Bild)
			SetBuffer ImageBuffer(Bild)
			Text 7,7,CurrentDate$()
			i = SaveImage(Bild,"Save\Speicher"+Str$(wahl)+".bmp")
			SetBuffer BackBuffer()
			CameraZoom camera,1
			RenderWorld()
			FreeImage Bild
			;
			If i = 0 Then ; erfolglos
				Meldung("Fehler: Spiel kann nicht gespeichert werden.")
				Meldung("Datei 'Save\Speicher"+Str$(wahl)+".bmp' schreibgeschtzt?")
				Exit
			EndIf
			; weiter...Daten speichern
			H_Datei = WriteFile("Save\Speicher"+Str$(wahl)+".dat")
			If H_Datei Then
				sx# = EntityX(ball)
				sy# = EntityY(ball)
				sz# = EntityZ(ball)
				If bahn = 16 Then wp# = EntityPitch(wippe)
				WriteInt(H_Datei,bahn)
				WriteInt(H_Datei,blickwahl)
				WriteFloat(H_Datei,EntityX(campivot))
				WriteFloat(H_Datei,EntityY(campivot))
				WriteFloat(H_Datei,EntityZ(campivot))
				WriteFloat(H_Datei,EntityPitch(camera))
				WriteFloat(H_Datei,EntityYaw(campivot))
				WriteFloat(H_Datei,ang#)
				WriteFloat(H_Datei,xi#)
				WriteFloat(H_Datei,yi#)
				WriteFloat(H_Datei,zi#)
				WriteFloat(H_Datei,a#)
				WriteFloat(H_Datei,sx#)
				WriteFloat(H_Datei,sy#)
				WriteFloat(H_Datei,sz#)
				WriteFloat(H_Datei,speed#)
				WriteFloat(H_Datei,putX#)
				WriteFloat(H_Datei,putZ#)
				WriteFloat(H_Datei,putZoom#)
				WriteFloat(H_Datei,putRotX#)
				WriteFloat(H_Datei,pfeilX#)
				WriteFloat(H_Datei,pfeilZ#)
				WriteFloat(H_Datei,bergalt#)
				WriteFloat(H_Datei,bergneu#)
				WriteFloat(H_Datei,bergdiff#)
				WriteFloat(H_Datei,wp#)
				WriteFloat(H_Datei,mausempf#)
				WriteInt(H_Datei,mausdreh)
				WriteInt(H_Datei,w_runter)
				WriteInt(H_Datei,breite)
				WriteInt(H_Datei,ballstatus)
				WriteInt(H_Datei,camstatus)
				WriteInt(H_Datei,huepfen)
				WriteInt(H_Datei,showfps)
				WriteInt(H_Datei,anzahl)
				WriteInt(H_Datei,gesamt)
				WriteInt(H_Datei,hinweise)
				WriteInt(H_Datei,soundon)
				WriteInt(H_Datei,abschlag)
				WriteInt(H_Datei,amAbschlag)
				WriteInt(H_Datei,training)
				WriteInt(H_Datei,rueckstellen)
				CloseFile(H_Datei)
				; neues Bild anzeigen
				Select wahl
					Case 1
						If bild1da Then	FreeImage bild1 : bild1 = 0
						Bild1 = LoadImage("Save\Speicher1.bmp")
						bild1da = 1
						ok1 = MilliSecs()+1000
					Case 2
						If bild2da Then FreeImage bild2 : bild2 = 0
						Bild2 = LoadImage("Save\Speicher2.bmp")
						bild2da = 1
						ok2 = MilliSecs()+1000
					Case 3
						If bild3da Then	FreeImage bild3 : bild3 = 0
						Bild3 = LoadImage("Save\Speicher3.bmp")
						bild3da = 1
						ok3 = MilliSecs()+1000
				End Select
				wahl = 0
			Else
				Meldung("Fehler: Spiel kann nicht gespeichert werden.")
				Meldung("Datei 'Save\Speicher"+Str$(wahl)+".dat' schreibgeschuetzt?")
			EndIf
		EndIf
	Forever
	If bild1da Then FreeImage bild1 : bild1 = 0
	If bild2da Then FreeImage bild2 : bild2 = 0
	If bild3da Then FreeImage bild3 : bild3 = 0
	MoveMouse mxalt,myalt ; Maus zurueck, sonst Aenderung der Blickrichtung
	While KeyDown(1) Or MouseDown(1)
	Wend
	FlushKeys()
	FlushMouse()
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Bahn laden...
; -----------------------------------------------------------------------------------------------
Function BahnLaden(w)
	Local temp$
	;-----------
	; Bahnwechsel
	bahnok = 0
	temp$ = "Bahnen\Bahn"+Str$(bahn)
	; Verzeichnis da? (sonst von vorne)
	If FileType(temp$) <> 2 Then
		If training Then
			bahn = 1
			temp$ = "Bahnen\Bahn1"
		Else
			If bahn > 1 Then bahn = bahn - 1
			Return
		EndIf
	EndIf
	; Bahnwechsel-Effekt (vor/zurueck)
	If w = 0 Then
		wechselplus = -scrW/25 ;-20
		wechselX = scrW*2
	EndIf
	If w = 1 Then
		wechselplus = scrW/25 ;20
		wechselX = 0
	EndIf
	If w < 2 Then
		wechsel = CreateImage(scrW*2,scrH*2)
		CopyRect 0,0,scrW*2,scrH*2,0,0,BackBuffer(),ImageBuffer(wechsel)
		wechselX = 0
	Else ; nicht beim Laden eines gespeicherten Spiels!
		wechsel = 0
	EndIf
	; Kollision
	ClearCollisions()
	; Bahnuntergrund
	If boden > 0 Then FreeEntity boden : boden = 0
	If FileType(temp$+"\Boden.b3d") = 1 Then ; nicht in jeder Bahn!
		boden = LoadMesh(temp$+"\Boden.b3d") : If boden = 0 Then RuntimeError "Modell '"+temp$+"\Boden.b3d' fehlt"
		MoveEntity boden,0,-0.2,0
		EntityType boden,COLL_BODEN
		Collisions COLL_BALL,COLL_BODEN,2,2
	EndIf
	; Lochkreis
	If kreis1 > 0 Then FreeEntity kreis1 : kreis1 = 0
	If FileType(temp$+"\Kreis.b3d") = 1 Then
		kreis1 = LoadMesh(temp$+"\Kreis.b3d") : If Kreis1 = 0 Then RuntimeError "Modell '"+temp$+"\Kreis.b3d' fehlt"
		MoveEntity kreis1,0,-0.2,0
		EntityType kreis1,COLL_KREIS
		Collisions COLL_BALL,COLL_KREIS,2,2
	EndIf
	; schraeg
	If wand45 > 0 Then FreeEntity wand45 : wand45 = 0
	If FileType(temp$+"\Wand-45.b3d") = 1 Then
		wand45 = LoadMesh(temp$+"\Wand-45.b3d") : If wand45 = 0 Then RuntimeError "Modell '"+temp$+"\Wand-45.b3d' fehlt"
		MoveEntity wand45,0,-0.3,0
		EntityType wand45,COLL_WALL45
		Collisions COLL_BALL,COLL_WALL45,2,2
	EndIf
	; seitlich
	If wand90 > 0 Then FreeEntity wand90 : wand90 = 0
	If FileType(temp$+"\Wand-90.b3d") = 1 Then
		wand90 = LoadMesh(temp$+"\Wand-90.b3d") : If wand90 = 0 Then RuntimeError "Modell '"+temp$+"\Wand-90.b3d' fehlt"
		MoveEntity wand90,0,-0.3,0
		EntityType wand90,COLL_WALL90
		Collisions COLL_BALL,COLL_WALL90,2,2
	EndIf
	; seitlich
	If wand135 > 0 Then FreeEntity wand135 : wand135 = 0
	If FileType(temp$+"\Wand-135.b3d") = 1 Then
		wand135 = LoadMesh(temp$+"\Wand-135.b3d") : If wand135 = 0 Then RuntimeError "Modell '"+temp$+"\Wand-135.b3d' fehlt"
		MoveEntity wand135,0,-0.3,0
		EntityType wand135,COLL_WALL135
		Collisions COLL_BALL,COLL_WALL135,2,2
	EndIf
	; vorne waagerecht
	If wand180 > 0 Then FreeEntity wand180 : wand180 = 0
	If FileType(temp$+"\Wand-180.b3d") = 1 Then
		wand180 = LoadMesh(temp$+"\Wand-180.b3d") : If wand180 = 0 Then RuntimeError "Modell '"+temp$+"\Wand-180.b3d' fehlt"
		MoveEntity wand180,0,-0.3,0
		EntityType wand180,COLL_WALL180
		Collisions COLL_BALL,COLL_WALL180,2,2
	EndIf
	; Poller/Wippe usw.
	If poller > 0 Then FreeEntity poller : poller = 0
	If poller2 > 0 Then FreeEntity poller2 : poller2 = 0
	If poller3 > 0 Then FreeEntity poller3 : poller3 = 0
	If wippe > 0 Then FreeEntity wippe : wippe = 0
	If ubau > 0 Then FreeEntity ubau : ubau = 0
	; Fische u. Wasser weg
	If gwasser > 0 Then FreeEntity gwasser : gwasser = 0
	If wasser2 > 0 Then FreeEntity wasser2 : wasser2 = 0
	If hub > 0 Then FreeEntity hub : hub = 0
	If fisch > 0 Then FreeEntity fisch : fisch = 0
	If fisch2 > 0 Then FreeEntity fisch2 : fisch2 = 0
	Select bahn
		Case 1
			If FileType(temp$+"\pyramide.b3d") = 1 Then
				poller = LoadMesh(temp$+"\pyramide.b3d") : If poller = 0 Then RuntimeError "Modell '"+temp$+"\Pyramide.b3d' fehlt"
				PositionEntity poller,0,-0.2,-9
				EntityType poller,COLL_POLLER
				poller2 = CopyEntity(poller)
				RotateEntity poller2,0,30,0
				PositionEntity poller2,-1,-0.2,-6.5
				EntityType poller2,COLL_POLLER
				poller3 = CopyEntity(poller)
				RotateEntity poller3,0,70,0
				PositionEntity poller3,0,-0.2,-4
				EntityType poller3,COLL_POLLER
				Collisions COLL_BALL,COLL_POLLER,2,2
			EndIf
		Case 4
			If FileType(temp$+"\poller.b3d") = 1 Then
				poller = LoadMesh(temp$+"\poller.b3d") : If poller = 0 Then RuntimeError "Modell '"+temp$+"\poller.b3d' fehlt"
				PositionEntity poller,0,-0.2,-6
				EntityType poller,COLL_POLLER
				Collisions COLL_BALL,COLL_POLLER,2,2
				Collisions COLL_BALL,COLL_POLLER,2,2
			EndIf
		Case 6
			If FileType(temp$+"\poller.b3d") = 1 Then
				poller = LoadMesh(temp$+"\poller.b3d") : If poller = 0 Then RuntimeError "Modell '"+temp$+"\poller.b3d' fehlt"
				PositionEntity poller,0,-0.3,-5.2
				EntityType poller,COLL_POLLER
				Collisions COLL_BALL,COLL_POLLER,2,2
			EndIf
			If FileType(temp$+"\Rohr.b3d") = 1 Then
				poller2 = LoadMesh(temp$+"\Rohr.b3d") : If poller2 = 0 Then RuntimeError "Modell '"+temp$+"\Rohr.b3d' fehlt"
				PositionEntity poller2,0,1.5,-5.1
				EntityType poller2,COLL_POLLER
				Collisions COLL_BALL,COLL_POLLER,2,2
				Collisions COLL_BALL,COLL_POLLER,2,2
			EndIf
		Case 13
			If FileType(temp$+"\poller.b3d") = 1 Then
				poller = LoadMesh(temp$+"\poller.b3d") : If poller = 0 Then RuntimeError "Modell '"+temp$+"\poller.b3d' fehlt"
				PositionEntity poller,0.6,-0.2,-4.5
				EntityType poller,COLL_POLLER
				Collisions COLL_BALL,COLL_POLLER,2,2
				poller2 = CopyEntity(poller)
				PositionEntity poller2,-0.6,-0.2,-9
				EntityType poller2,COLL_POLLER
				Collisions COLL_BALL,COLL_POLLER,2,2
			EndIf
		Case 14
			If FileType(temp$+"\poller.b3d") = 1 Then
				poller = LoadMesh(temp$+"\poller.b3d") : If poller = 0 Then RuntimeError "Modell '"+temp$+"\poller.b3d' fehlt"
				EntityType poller,COLL_POLLER
				Collisions COLL_BALL,COLL_POLLER,2,2
			EndIf
		Case 15
			If FileType(temp$+"\poller2.b3d") = 1 Then
				poller = LoadMesh(temp$+"\poller2.b3d") : If poller = 0 Then RuntimeError "Modell '"+temp$+"\poller2.b3d' fehlt"
				PositionEntity poller,1,-0.2,-5.5
				EntityType poller,COLL_POLLER
				Collisions COLL_BALL,COLL_POLLER,2,2
			EndIf
			If FileType(temp$+"\poller.b3d") = 1 Then
				poller2 = LoadMesh(temp$+"\poller.b3d") : If poller2 = 0 Then RuntimeError "Modell '"+temp$+"\poller.b3d' fehlt"
				PositionEntity poller2,-1,-0.2,-5
				EntityType poller2,COLL_POLLER
				Collisions COLL_BALL,COLL_POLLER,2,2
			EndIf
		Case 16
			If FileType(temp$+"\wippe.b3d") = 1 Then
				wippe = LoadMesh(temp$+"\wippe.b3d") : If wippe = 0 Then RuntimeError "Modell '"+temp$+"\wippe.b3d' fehlt"
				PositionEntity wippe,0,0.8,-6
				RotateEntity wippe,-20,0,0
				EntityType wippe,COLL_BODEN
			EndIf
			; Unterbau der Wippe
			If FileType(temp$+"\poller.b3d") = 1 Then
				poller = LoadMesh(temp$+"\poller.b3d") : If poller = 0 Then RuntimeError "Modell '"+temp$+"\poller.b3d' fehlt"
				PositionEntity poller,-2,-0.2,-6
				EntityType poller,COLL_POLLER
				poller2 = CopyEntity(poller)
				PositionEntity poller2,2,-0.2,-6
				EntityType poller2,COLL_POLLER
				Collisions COLL_BALL,COLL_POLLER,2,2
			EndIf
			If FileType(temp$+"\ubau.b3d") = 1 Then
				ubau = LoadMesh(temp$+"\ubau.b3d") : If ubau = 0 Then RuntimeError "Modell '"+temp$+"\ubau.b3d' fehlt"
				PositionEntity ubau,0,-0.2,-6
				EntityType ubau,COLL_WALL180
			EndIf
		Case 17
			If FileType(temp$+"\text.b3d") = 1 Then
				poller = LoadMesh(temp$+"\text.b3d") : If poller = 0 Then RuntimeError "Modell '"+temp$+"\text.b3d' fehlt"
				PositionEntity poller,0,-0.2,-6
				EntityType poller,COLL_POLLER
				Collisions COLL_BALL,COLL_POLLER,2,2
			EndIf
		Case 18
			gwasser = CreateSprite()
			SpriteViewMode gwasser,2
			RotateEntity gwasser,90,0,0
			ScaleSprite gwasser,2.5,1.2
			PositionEntity gwasser,0,-0.2,-8
			gtex = LoadTexture(temp$+"\cloud_2.png",3)
			If gtex = 0 Then RuntimeError "Texture '"+temp$+"\cloud_2.png' fehlt"
			EntityTexture gwasser,gtex
			EntityAlpha gwasser,0.5
			If FileType(temp$+"\wasser2.b3d") = 1 Then
				wasser2 = LoadMesh(temp$+"\wasser2.b3d") : If wasser2 = 0 Then RuntimeError "Modell '"+temp$+"\wasser2.b3d' fehlt"
				TranslateEntity wasser2,0,0.15,0
			EndIf
			If FileType(temp$+"\hub.b3d") = 1 Then
				hub = LoadMesh(temp$+"\hub.b3d") : If hub = 0 Then RuntimeError "Modell '"+temp$+"\hub.b3d' fehlt"
				TranslateEntity hub,0,-0.25,-9.5
				EntityType hub,COLL_HUB
				Collisions COLL_BALL,COLL_HUB,2,2
			EndIf
			; Fische
			poller = LoadMesh(temp$+"\FischPoller.b3d") : If poller = 0 Then RuntimeError "Modell '"+temp$+"\FischPoller.b3d' fehlt"
			poller2 = CopyEntity(poller)
			PositionEntity poller2,-1,-0.03,-1
			EntityType poller2,COLL_POLLER
			poller3 = CopyEntity(poller)
			PositionEntity poller3,1.5,-0.03,1
			EntityType poller3,COLL_POLLER
			PositionEntity poller,0,-0.03,-4
			EntityType poller,COLL_POLLER
			Collisions COLL_BALL,COLL_POLLER,2,2
			fisch = LoadMesh(temp$+"\Fisch.b3d") : If fisch = 0 Then RuntimeError "Modell '"+temp$+"\Fisch.b3d' fehlt"
			fisch2 = LoadMesh(temp$+"\Fisch2.b3d") : If fisch2 = 0 Then RuntimeError "Modell '"+temp$+"\Fisch2.b3d' fehlt"
			PositionEntity fisch,Rnd(-1.5,1.5),-1,Rnd(-7.2,-8.9)
			PositionEntity fisch2,Rnd(-1.5,1.5),-1,Rnd(-7.2,-8.9)
			fischauf = 0
			fischneu = 0
			fischauf2 = 0
			fischneu2 = 0
	End Select
	; Sprite fuer Bahnnummer
	If bahnNr > 0 Then FreeEntity bahnNr : bahnNr = 0
	bahnNr = LoadSprite(temp$+"\bahn"+Str$(bahn)+".png") : If bahnNr = 0 Then RuntimeError "Sprite '"+temp$+"\Bahn"+Str$(bahn)+".png' fehlt"
	SpriteViewMode bahnNr,2
	ScaleSprite bahnNr,0.5,0.25
	EntityFX bahnNr,17
	TurnEntity bahnNr,90,0,0 ; flach
	; Bahnwerte ------------------------------------
	Bahnlesen()
	PositionEntity bahnNr,bahndaten#(1),bahndaten#(2),bahndaten#(3) ; Position Bahnnummer: links vom Abschlag
	Sicht()
	bahnok = 1
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Bahndaten aus externer Datei laden
; -----------------------------------------------------------------------------------------------
Function Bahnlesen()
	Local infile, temp$, i
	;----------------------
	temp$ = "Bahnen\Bahn"+Str$(bahn)
	infile = ReadFile(temp$+"\Bahn"+Str$(bahn)+".dat")
	If infile
		For i = 1 To 17
			bahndaten#(i) = ReadLine(infile)
		Next
		CloseFile(infile)
		; x,y,z des Bahn-Nummer-Schildes
		; x, z der Abschlagsposition
		; Abschlagsicht (6 bis 11)
		; 2D-Sicht ( 12 bis 17)
	Else
		Meldung("Fehler: Daten fr Bahn nicht gefunden: "+temp$+"\Bahn"+Str$(bahn)+".dat")
	EndIf
End Function
;
;
; -----------------------------------------------------------------------------------------------
; 3 Blick-Ausgangswerte je Bahn
; -----------------------------------------------------------------------------------------------
Function Sicht()
	Local j
	;--------
	j = blickwahl * 6 + 6
	RotateEntity Camera,bahndaten(j),bahndaten(j+1),bahndaten(j+2)
	PositionEntity camera,bahndaten(j+3),bahndaten(j+4),bahndaten(j+5)
	PositionEntity campivot,EntityX(camera),EntityY(camera),EntityZ(camera)
	RotateEntity Campivot,0,EntityYaw#(camera),0
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Schrift fuer Hinweise
; -----------------------------------------------------------------------------------------------
Function Schrift(txt$,x,y)
	Local lang, i, j
	;---------------
	lang = Len(txt$)
	For i = 1 To lang
		j = (Asc(Mid(txt$,i,1)))-32
		If j < 223 Then
			DrawImage fntcouNew8f,x,y,j
			x = x + 10
		EndIf    
	Next
End Function
;
Function Schrift2(txt$,x,y) ; mit gruenem Hintergrund
	Local lang, i, j
	;---------------
	lang = Len(txt$)
	Color 0,70,0
	Rect x,y+3,lang*10+10,13,1
	For i = 1 To lang
		j = (Asc(Mid(txt$,i,1)))-32
		If j < 223 Then
			DrawImage fntcouNew8f,x,y,j
			x = x + 10
		EndIf    
	Next
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Meldung ausgeben
; -----------------------------------------------------------------------------------------------
Function Meldung(txt$)
	Local a,x,y,iii, altmx, altmy
	;----------------------------
	altmx = MouseX()
	altmy = MouseY()
	a = 30+Len(txt$)*10
	x = scrW-(a/2)-30
	y = scrH-30
	Color 251,5,34 ; rot
	Rect x,y,a+60,40,1 ; Rahmen
	Color 0,0,0
	Rect x+30,y+10,a,20,1 ; schwarzer Hintergrund
	Color 253,149,166 ; hellerer aeusserer u. innerer Rand (3D-Effekt) rot
	Line x,y,x+a+60,y : Line x,y,x,y+40 : Line x+30,y+30,x+a+30,y+30 : Line x+a+30,y+10,x+a+30,y+30
	Schrift(txt$,x+39,y+12)
	If ballstatus = 0 Then ; im Titelbild beim Laden wenn kein Spiel gespeichert ist 
		Schrift("Start     Spiel laden",scrW-90,scrH+170)
		Schrift("Hilfe",scrW-88,scrH+190)
		Schrift("Highscore",scrW+20,scrH+190)
		Schrift("Optionen",scrW-105,scrH+211)
		Schrift("Ende",scrW+45,scrH+211)
	EndIf
	Flip
	Delay 1500
	MoveMouse altmx,altmy
	FlushMouse()
	FlushKeys()
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Moewe zeigen / Absturz
; -----------------------------------------------------------------------------------------------
Function Moewezeigen()
	Select absturzzeit
		Case 1
			vogela = 1
			vogelb = 10
			vogelricht# = -0.3
			i = Rand(10,20) ; Hoehe zufaellig
			PositionEntity flug1,30,i,150 ; z = 150 bis -150
			PositionEntity flug2,30,i,150 ; x = -100 bis 150
			PositionEntity rumpf,30,i,150
			RotateEntity flug1,0,0,0
			RotateEntity flug2,0,0,0
			RotateEntity rumpf,0,0,0
			ShowEntity flug1
			ShowEntity flug2
			ShowEntity rumpf
			absturzzeit = 2 ; = normal einmal fliegen
		Case 2 ; normal fliegen bis zum Gelaenderand
			If vogela > 50 Or vogela < -40 Then vogelb = -vogelb
			vogela = vogela + vogelb
			moe# = 0.1*Sin(vogela)
			TurnEntity flug1,0,0,vogelb
			TurnEntity flug2,0,0,-vogelb
			TranslateEntity flug1,0,moe#,vogelricht#
			TranslateEntity flug2,0,moe#,vogelricht#
			TranslateEntity rumpf,0,moe#,vogelricht#
			; am Gelaenderand beenden
			If EntityZ(rumpf) < -150 Or EntityZ(rumpf) > 150 Then
				HideEntity flug1
				HideEntity flug2
				HideEntity rumpf
				absturzzeit = 0
			EndIf
		Case 3 ; Absturz
			TurnEntity absturz,0,30,0
			TranslateEntity absturz,0,-0.4,0
			If EntityY(absturz) < 0 Then
				ax# = EntityX(absturz)
				az# = EntityZ(absturz)
				PositionEntity absturz,-12,-4,EntityZ(absturz)
				HideEntity absturz
				;
				PositionEntity flug1,ax#,0.2,az#
				PositionEntity flug2,ax#,0.2,az#
				PositionEntity rumpf,ax#,0.2,az#
				RotateEntity flug1,0,0,0
				RotateEntity flug2,0,0,0
				RotateEntity rumpf,0,0,0
				ShowEntity flug1
				ShowEntity flug2
				ShowEntity rumpf
				vogela = 1
				vogelb = 10
				vogelricht# = -0.3
				absturzzeit = 4
				warten = MilliSecs() + 500
			EndIf
		Case 4
			If vogela > 50 Or vogela < -40 Then vogelb = -vogelb
			vogela = vogela + vogelb
			TurnEntity flug1,30,0,vogelb*5
			TurnEntity flug2,30,0,vogelb*5
			TurnEntity rumpf,30,0,vogelb*5
			If MilliSecs() > warten Then
				RotateEntity flug1,0,0,0
				RotateEntity flug2,0,0,0
				RotateEntity rumpf,0,0,0
				vogela = 1
				vogelb = 10
				vogelricht# = -0.3
				absturzzeit = 5
				warten = MilliSecs() + 1000
			EndIf
		Case 5
			If vogela > 40 Or vogela < -40 Then vogelb = -vogelb
			vogela = vogela + vogelb
			TurnEntity flug1,0,0,0.5*vogelb
			TurnEntity flug2,0,0,0.5*vogelb
			If MilliSecs() > warten Then
				RotateEntity flug1,0,0,0
				RotateEntity flug2,0,0,0
				RotateEntity rumpf,0,0,0
				vogela = 1
				vogelb = 10
				vogelricht# = -0.3
				absturzzeit = 6
			EndIf
		Case 6
			If vogela > 50 Or vogela < -40 Then vogelb = -vogelb
			vogela = vogela + vogelb
			moe# = 0.1*Sin(vogela)+0.1
			TurnEntity flug1,0,0,vogelb
			TurnEntity flug2,0,0,-vogelb
			TranslateEntity flug1,0,moe#,vogelricht#
			TranslateEntity flug2,0,moe#,vogelricht#
			TranslateEntity rumpf,0,moe#,vogelricht#
			If EntityY(rumpf) > 10 Then absturzzeit = 2 ; eine Strecke fliegen lassen
	End Select
End Function
;
;
; --------------------------------------------------------------------------------------------------
; Nessie im Teich auftauchen lassen
; --------------------------------------------------------------------------------------------------
Function Nessiezeigen()
	If nessiezeit = 1 Then
		If nessieY# < 3.0 Then ; auftauchen
			nessieY# = nessieY# + 0.02
			PositionEntity nessiebauch,100,nessieY#,nessieZ#
			PositionEntity nessiekopf,100,nessieY#,nessieZ#
			PositionEntity nessiezunge,100,nessieY#,nessieZ#
		Else ; Kopf drehen, zuengeln
			TurnEntity nessiekopf,0,nessiedreh,0
			TurnEntity nessiezunge,0,nessiedreh,0
			If MilliSecs() > nzeit Then ; zuengeln
				nalpha = 1 - nalpha
				EntityAlpha nessiezunge,nalpha 
				nzeit = MilliSecs() + 100
			EndIf
			If EntityYaw(nessiezunge) > 130 Then nessiedreh = -1
			If EntityYaw(nessiezunge) < -20 Then HideEntity nessiezunge : nessiezeit = 2
		EndIf
	Else ; wegtauchen
		If nessieY# > -8 Then
			nessieY# = nessieY# - 0.02
			PositionEntity nessiebauch,100,nessieY#,nessieZ#
			PositionEntity nessiekopf,100,nessieY#,nessieZ#
		Else
			nessiezeit = 0
			HideEntity nessiebauch
			HideEntity nessiekopf
		EndIf
	EndIf
End Function
;
;
; --------------------------------------------------------------------------------------------------
; Name holen fuer Highscore-Eintrag
; --------------------------------------------------------------------------------------------------
Function Name_holen()
	Local x, y, Stelle = 1
	;---------------------
	x = scrW-270
	y = scrH-270
	RSet$(akt_Name$,12)                    ; alten Namen auf 12 Stellen auffuellen
	For i = 1 To 12                        ; Name in Array uebernehmen
		h_nam$(i) = Mid$(akt_name$,i,1)
	Next
	;
	Delay 100
	FlushKeys()
	FlushMouse()
	While Not KeyHit(28) Or KeyHit(1) Or MouseHit(1)
		RenderWorld()
		If KeyHit(205)                     ; rechts
			Stelle = Stelle + 1
			If Stelle > 12 Then Stelle = 12
		EndIf
		If KeyHit(203)                     ; links
			Stelle = Stelle - 1
			If Stelle < 1 Then Stelle = 1
		EndIf
		If KeyHit(211)                     ; delete
			For i = Stelle To 11
				h_nam$(i) = h_nam$(i+1)
			Next
			h_nam$(12)=" " 
		EndIf
		If KeyHit(14)                      ; Backspace
			Stelle = Stelle - 1
			If Stelle < 1 Then Stelle = 1
			For i = Stelle To 11
				h_nam$(i) = h_nam$(i+1)
			Next
			h_nam$(12)=" " 
		EndIf
		If ein=32 Or ein>47 And ein<123 Or ein=214 Or ein=246 Or ein=252 Or ein=220 Or ein=228 Or ein=196 Or ein=223 Then
			If Stelle < 13
				h_nam$(Stelle) = Upper$(Chr$(ein))
				Stelle = Stelle + 1
				If Stelle > 12 Then Stelle = 1
			EndIf
		EndIf
		High_Plot()
		Schrift2("Eingabe beenden mit RETURN",x+140,y+540)
		; Rahmen
		Color 0,0,0
		Rect x + 26,y+(iNeueZeile*25),130,23,1
		Color 0,255,0
		Rect x + 26,y+(iNeueZeile*25),130,23,0
		;
		For i = 1 To 12
			Schrift(h_nam$(i),x+15+i*10,y+iNeueZeile*25) ; Schrift
		Next
		Color 255,0,0
		Rect x + 20 + (Stelle*10),(y+18)+(iNeueZeile*25),13,4 ; Cursor
		Flip
		ein = GetKey()
	Wend
	akt_Name$=""
	For i = 1 To 12
		akt_name$ = akt_name$ + h_nam$(i)  ; Eingabe uebernehmen in akt_Name$
	Next
	H_Name$(iNeueZeile) = akt_Name$
	High_schreiben()
	High_zeigen()
End Function
;
;
; --------------------------------------------------------------------------------------------------
; Aktuelle Punktzahl in Highscore einordnen
; --------------------------------------------------------------------------------------------------
Function High_einordnen()
	For i = 20 To 1 Step -1
		If gesamt < H_Punkte(i) Then
			H_Name$(i+1)  = H_Name$(i)
			H_Datum$(i+1) = H_Datum$(i)
			H_Punkte(i+1) = H_Punkte(i)
		Else
			Exit
		EndIf
	Next
	i = i + 1
	iNeueZeile = i ; fuer die rote Markierung des neuen Eintrags
	H_Name$(i) = ""
	H_Datum$(i)= CurrentDate$()
	H_Punkte(i)= gesamt
End Function
;
;
; --------------------------------------------------------------------------------------------------
; Highscoreliste schreiben
; --------------------------------------------------------------------------------------------------
Function High_schreiben()
	Local H_Datei
	;-------------
	H_Datei = WriteFile("Minigolf.dat")
	If H_Datei Then
		For i = 1 To 20
			WriteString(H_Datei,H_Name$(i))
			WriteString(H_Datei,H_Datum$(i))
			WriteInt(H_Datei,H_Punkte(i))
		Next
		CloseFile(H_Datei)
	Else
		Meldung("Fehler. Minigolf.dat schreibgeschuetzt?")
	EndIf
End Function
;
;
; --------------------------------------------------------------------------------------------------
; Highscoreliste laden
; --------------------------------------------------------------------------------------------------
Function High_laden()
	Local H_Datei, i
	;----------------
	H_Datei = ReadFile("Minigolf.dat")
	If H_Datei Then                 ; Datei gefunden: lesen
		For i = 1 To 20
			H_Name$(i)  = ReadString$(H_Datei)
			H_Datum$(i) = ReadString$(H_Datei)
			H_Punkte(i) = ReadInt(H_Datei)
		Next
		CloseFile(H_Datei)
	Else                            ; Datei nicht gefunden: anlegen
		H_Datei = WriteFile("Minigolf.dat")
		If H_Datei Then
			For i = 1 To 20
				WriteString(H_Datei,"------------")
				WriteString(H_Datei,"-----------")
				WriteInt(H_Datei,126)
				H_Name$(i)  = "------------"
				H_Datum$(i) = "-----------"
				H_Punkte(i) = 126
			Next
			CloseFile(H_Datei)
		Else
			Meldung("Fehler. Minigolf.dat schreibgeschuetzt?")
		EndIf
	End If
	iNeueZeile = 0 ; sonst ist beim Optionen-Wechsel in neuer Liste alte rote Zeile noch rot
End Function
;
;
; --------------------------------------------------------------------------------------------------
; Highscoreliste zeigen und ggf. loeschen
; --------------------------------------------------------------------------------------------------
Function High_zeigen()
	Local i, x, y
	;-------------
	x = scrW+20
	y = scrH
	FlushKeys()
	FlushMouse()
	Repeat
		RenderWorld()
		High_Plot()
		Schrift2("Loeschen = L      weiter = ESC",x-170,y+270)
		Flip
		i = GetKey()
		If i = 27 Or i = 13 Or i=104 Or KeyHit(87) Or MouseHit(1) Then Exit ; ESC, Return, h oder Mausklick
		If i = 76 Or i = 108 Then ; grosses oder kleines L
			i = 0 ; sonst sofort beendet...
			Repeat
				RenderWorld()
				i = GetKey()
				If i = 74 Or i = 106 Then
					For i = 1 To 20 ; Highscore auf Null
						H_Name$(i)   = "------------"
						H_Datum$(i)  = "-----------"
						H_Punkte(i)  = 126
					Next
					iNeueZeile = 0
					High_schreiben()
				EndIf
				;
				High_Plot()
				Color 255,0,0 ; roter Hintergrund
				Rect x-175,y+269,350,22,1
				Schrift("Wirklich loeschen? (Ja = J)",x-140,y+270)
				Flip
				If i > 0 Then Exit ; ESC oder Return
			Forever
		EndIf
		If MouseHit(1) Or KeyHit(1) Or KeyHit(57) Or KeyHit(28) Or KeyHit(68) Then Exit
	Forever
	While MouseDown(1) Or KeyHit(1)
	Wend
	FlushMouse()
	FlushKeys()
End Function
;
;
; --------------------------------------------------------------------------------------------------
; Highscoreliste zeichnen
; --------------------------------------------------------------------------------------------------
Function High_plot()
	Local i, x1, y1
	;---------------
	x1 = scrW+20
	y1 = scrH
	If KeyHit(60) Then massiv = 1 - massiv ; gruenen Hintergrund zeigen
	If KeyHit(67) Then SShot() ; F9 = Screenshot erstellen
	If massiv Then
		Color 0,70,0
		Rect scrW-317,scrH-327,634,624,1
	EndIf
	Schrift2("HIGHSCORELISTE",x1-90,y1-318)
	Schrift2("Name",x1-265,y1-285)
	Schrift2("Datum",x1,y1-285)
	Schrift2("Schlge",x1+210,y1-285)
	x1 = x1 - 230
	y1 = y1 - 270
	For i = 1 To 20
		Schrift2(Right$(" " + Str$(i),2),x1-100,y1+i*25)
		Schrift2(H_Name$(i),x1-35,y1+i*25)
		Schrift2(H_Datum$(i),x1+200,y1+i*25)
		Schrift2(Right$("         "+Str$(H_Punkte(i)),5),x1+450,y1+i*25)
	Next
End Function
;
;
Function High_plot2() ; mit gruenem Hintergrund
	Local i, x1, y1
	;---------------
	x1 = scrW+20
	y1 = scrH
	If KeyHit(60) Then massiv = 1 - massiv ; gruenen Hintergrund zeigen
	If KeyHit(67) Then SShot() ; F9 = Screenshot erstellen
	If massiv Then
		Color 0,70,0
		Rect scrW-317,scrH-327,634,624,1
	EndIf
	Schrift2("HIGHSCORELISTE",x1-90,y1-318)
	Schrift2("Name",x1-265,y1-285)
	Schrift2("Datum",x1,y1-285)
	Schrift2("Schlge",x1+210,y1-285)
	x1 = x1 - 230
	y1 = y1 - 270
	For i = 1 To 20
		Schrift2(Right$(" " + Str$(i),2),x1-100,y1+i*25)
		Schrift2(H_Name$(i),x1-35,y1+i*25)
		Schrift2(H_Datum$(i),x1+200,y1+i*25)
		Schrift2(Right$("         "+Str$(H_Punkte(i)),5),x1+450,y1+i*25)
	Next
	If loeschen = 0 Then
		Schrift2("Loeschen = L      weiter = ESC",scrW-150,scrH+270)
		If KeyHit(38) Then loeschen = 1 : FlushKeys()
		; nur hier raus...
		If KeyHit(1) Or KeyHit(28) Or KeyHit(57) Or KeyHit(59) Or MouseHit(1) Then punkt = 0
	Else
		Color 255,0,0 ; roter Hintergrund
		Rect scrW-155,scrH+269,350,22,1
		Schrift("Wirklich loeschen? (Ja = J)",scrW-120,scrH+270)
		i = GetKey()
		If i = 74 Or i = 106 Then
			For i = 1 To 20 ; Highscore auf Null
				H_Name$(i) = "------------"
				H_Datum$(i) = "-----------"
				H_Punkte(i) = 126
			Next
			High_schreiben()
		EndIf
		If i > 0 Then loeschen = 0 : FlushKeys() : FlushMouse()
	EndIf
	;
	If punkt = 0 Then MoveMouse scrW-30,scrH+180 : FlushKeys() : FlushMouse()
End Function
;
;
; -----------------------------------------------------------------------------------------------
; erste Seite der Hilfe
; -----------------------------------------------------------------------------------------------
Function Hilfe0()
	Local mx,my
	;-----------
	mx = MouseX()
	my = MouseY()
	Color 255,0,0
	Rect scrW-322,scrH-166,644,314,0
	Color 255,255,255
	Rect scrW-324,scrH-168,648,318,0
	DrawBlock tasten,scrW-320,scrH-165
	DrawImage pointer,mx,my
	If KeyHit(67) Then SShot() ; F9 = Screenshot
	If KeyHit(60) Then massiv = 1 - massiv ; gruener Hintergrund
	If KeyHit(1) Then punkt = 0
	If KeyHit(28) Or KeyHit(57) Or KeyHit(59) Or MouseHit(1) Then punkt = 2
End Function
;
;
; -----------------------------------------------------------------------------------------------
; zweite Seite der Hilfe
; -----------------------------------------------------------------------------------------------
Function Hilfe1()
	Local mx,my
	;-----------
	mx = MouseX()
	my = MouseY()
	Color 255,0,0
	Rect scrW-298,scrH-258,596,516,0
	Color 255,255,255
	Rect scrW-300,scrH-260,600,520,0
	If massiv Then
		Color 0,70,0
		Rect scrW-297,scrH-257,594,514,1
	EndIf
	Schrift2("Minigolf - HILFE",scrW-100,scrH-245)
	Schrift2("Gespielt wird mit der Maus.",scrW-280,scrH-210)
	Schrift2("Maus links/rechts bewegen       = Schlger drehen.",scrW-280,scrH-180)
	Schrift2("Linke Maustaste gedrckt halten = Schlagstrke.",scrW-280,scrH-160)
	Schrift2("Linke Maustaste loslassen       = Schlag.",scrW-280,scrH-140)
	Schrift2("Rechte Maustaste drcken = vor/zurck/links/rechts,",scrW-280,scrH-105)
	Schrift2("                           drehen mit Mausrad",scrW-280,scrH-90)
	Schrift2("Mit F2 knnen 2 Blickwinkel durchgeschaltet werden,",scrW-280,scrH-60)
	Schrift2("die auch bei der nchsten Bahn erhalten bleiben.",scrW-280,scrH-45)
	Schrift2("Mit Ziffernblock bzw. A,D,W,X usw. kann der Blick-",scrW-280,scrH-10)
	Schrift2("winkel verstellt werden. Tab, S oder 5 stellen wieder",scrW-280,scrH+5)
	Schrift2("die Standardsicht ein.",scrW-280,scrH+20)
	Schrift2("Mit F8 kann zwischen Training und Turnier umgeschaltet",scrW-280,scrH+55)
	Schrift2("werden.",scrW-280,scrH+70)
	Schrift2("Turnier : alle Bahnen nacheinander mit maximal 6",scrW-280,scrH+120)
	Schrift2("          Schlgen (+1 Strafpunkt) und Highscore.",scrW-280,scrH+133)
	Schrift2("Training: Beliebige Auswahl der Bahnen, bliebige",scrW-280,scrH+160)
	Schrift2("          Schlagzahl.",scrW-280,scrH+173)
	Schrift2("Spiel speichern mit F6.",scrW-280,scrH+210)
	DrawImage pointer,mx,my
	If KeyHit(67) Then SShot() ; F9 = Screenshot
	If KeyHit(60) Then massiv = 1 - massiv ; gruener Hintergrund
	If KeyHit(1) punkt = 0
	If KeyHit(28) Or KeyHit(57) Or KeyHit(59) Or MouseHit(1) Then punkt = 3
End Function
;
;
; -----------------------------------------------------------------------------------------------
; dritte Seite der Hilfe
; -----------------------------------------------------------------------------------------------
Function Hilfe2()
	Local mx,my
	;-----------
	mx = MouseX()
	my = MouseY()
	Color 255,0,0
	Rect scrW-298,scrH-258,596,516,0
	Color 255,255,255
	Rect scrW-300,scrH-260,600,520,0
	If massiv Then
		Color 0,70,0
		Rect scrW-297,scrH-257,594,514,1
	EndIf
	Schrift2("Minigolf - HILFE",scrW-100,scrH-245)
	Schrift2("Drehen:             Maus bewegen / Pfeiltasten",scrW-280,scrH-180)
	Schrift2("Abschlagen:         linke Maustaste / Return",scrW-280,scrH-160)
	Schrift2("Hilfe:              F1",scrW-280,scrH-140)
	Schrift2("Blickzentrum:       F2 (Abschlag/2D-Sicht)",scrW-280,scrH-120)
	Schrift2("Blickwinkel: bei gedrckter rechter Maustaste bewegen",scrW-280,scrH-100)
	Schrift2("Vorherige Bahn:     F3 (nur im Training)",scrW-280,scrH-80)
	Schrift2("Nchste Bahn:       F4 oder Leertaste (nur im Training)",scrW-280,scrH-60)
	Schrift2("Neuer Ball:         F5/ESC",scrW-280,scrH-40)
	Schrift2("Speichern/Laden:    F6",scrW-280,scrH-20)
	Schrift2("Sound an/aus:       F7",scrW-280,scrH)
	Schrift2("Training/Turnier:   F8",scrW-280,scrH+20)
	Schrift2("Screenshot:         F9",scrW-280,scrH+40)
	Schrift2("Highscoreliste:     F10",scrW-280,scrH+60)
	Schrift2("Hinweise ein/aus:   F11, H",scrW-280,scrH+80)
	Schrift2("Bildrate (fps):     F12",scrW-280,scrH+100)
	Schrift2("Startsicht:         Tab, S oder 5 (auf Ziffernblock)",scrW-280,scrH+120)
	Schrift2("A,D,W,X usw. oder Ziffernblock: Blick ndern",scrW-280,scrH+140)
	Schrift2("Taste 1,2,3 usw.:   Direktwahl der Bahnen",scrW-280,scrH+160)
	Schrift2("ESC = Abschlag/Titelbild/Programmende",scrW-280,scrH+210)
	DrawImage pointer,mx,my
	If KeyHit(67) Then SShot() ; F9 = Screenshot
	If KeyHit(60) Then massiv = 1 - massiv
	If KeyHit(1) Or KeyHit(28) Or KeyHit(57) Or KeyHit(59) Or MouseHit(1) Then
		MoveMouse scrW-30,scrH+180
		punkt = 0
	EndIf
	While KeyDown(28) Or MouseDown(1)
	Wend
	FlushKeys()
	FlushMouse()
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Start-Ansicht vor renderworld
; -----------------------------------------------------------------------------------------------
Function Titel1()
	If MouseHit(2) Then MouseXSpeed() : MouseYSpeed() : MouseZSpeed()
	If MouseDown(2) Then
		MoveEntity campivot,-MouseXSpeed() * mausempf#,0,0
		MoveEntity campivot,0,0,MouseYSpeed() * mausempf#
		TurnEntity campivot,0,mausdreh * MouseZSpeed(),0
		MoveMouse scrW,scrH ; center Maus
	EndIf
	; links/rechts
	If KeyDown(77) Or KeyDown(32) Then MoveEntity campivot,-0.5,0,0 : aend = 1 ;6 oder D
	If KeyDown(75) Or KeyDown(30) Then MoveEntity campivot,0.5,0,0 : aend = 1 ;4 oder A
	; rauf/runter
	If KeyDown(73) Or KeyDown(18) Then MoveEntity campivot,0,0.5,0 : aend = 1 ;9 oder E
	If (KeyDown(81) Or KeyDown(46)) And EntityY(campivot) > 1 Then MoveEntity campivot,0,-0.5,0 : aend = 1 ;3 oder C
	; vor, zurueck
	If KeyDown(72) Or KeyDown(17) Then MoveEntity campivot,0,0,-0.5 : aend = 1 ;8 oder W
	If KeyDown(80) Or KeyDown(45) Then MoveEntity campivot,0,0,0.5 : aend = 1 ;2 oder X
	; drehen
	If KeyDown(82) Or KeyDown(29) Then TurnEntity campivot,0,-2,0 ; 0 oder strg links
	If KeyDown(83) Or KeyDown(42) Then TurnEntity campivot,0,2,0 ; , oder shift links
	; rauf-/runterdrehen
	If KeyDown(71) Or KeyDown(16) Then TurnEntity camera,-1,0,0 ;7 oder Q
	If KeyDown(79) Or KeyDown(44) Then TurnEntity camera,1,0,0 ;1 oder Y
	;
	If KeyHit(76) Or KeyHit(31) Or KeyHit(15) Then ; Tab, S oder Ziffernblock 5 = Startblick
		PositionEntity camera,-20,10,-20
		RotateEntity camera,15,-50,0
		PositionEntity campivot,EntityX(camera),EntityY(camera),EntityZ(camera)
		RotateEntity campivot,15,-50,0
		If nessiezeit = 0 Then nessiezeit = 1 ; Nessie, falls nicht unterwegs (nessiezeit = 1 oder 2)
	EndIf
	; F9 = Screenshot	
	If KeyHit(67) Then SShot()
	; F12 = Framecounter anzeigen
	If KeyHit(88) Then showfps = 1 - showfps
	; Moewe
	If vogelzeit = 1 Then
		If vogela > 50 Or vogela < -40 Then vogelb = -vogelb
		vogela = vogela + vogelb
		moe# = 0.1*Sin(vogela)
		TurnEntity flug1,0,0,vogelb
		TurnEntity flug2,0,0,-vogelb
		TranslateEntity flug1,0,moe#,vogelricht#
		TranslateEntity flug2,0,moe#,vogelricht#
		TranslateEntity rumpf,0,moe#,vogelricht#
		; wenden
		If KeyHit(53) Or EntityZ(rumpf) < -150 Or EntityZ(rumpf) > 150 Then
			vogelricht# = -vogelricht#
			If vogelricht# > 0 Then i = 180 Else i = 0 
			RotateEntity flug1,0,i,0
			RotateEntity flug2,0,i,0
			RotateEntity rumpf,0,i,0
			vogela = 1
			vogelb = 10
			i = Rand(5,15) ; Hoehe zufaellig
			PositionEntity flug1,EntityX(flug1),i,EntityZ(flug1) ; z = 150 bis -150
			PositionEntity flug2,EntityX(flug2),i,EntityZ(flug2) ; x = -100 bis 150
			PositionEntity rumpf,EntityX(rumpf),i,EntityZ(rumpf)
		EndIf 
	EndIf
	; Nessie
	If nessiezeit > 0 Then ; Nessie kommt...
		Nessiezeigen()
	Else
		If nessiekommt Or KeyHit(49) Then ; N = Nessie-Taste...
			nessieY# = -8
			nessieZ# = Rand(-50,100) ; +100 bis -50
			nessiedreh = 2
			PositionEntity nessiebauch,100,-2.5,nessieZ#
			PositionEntity nessiekopf,100,-2.5,nessieZ#
			ShowEntity nessiebauch
			ShowEntity nessiekopf
			ShowEntity nessiezunge			
			nessiezeit = 1
		EndIf
	EndIf
	; im Titelbild pro Runde 1 mal Nessie
	If EntityYaw(camera) > 1 And EntityYaw(camera) < 2 And nessiezeit = 0 Then nessiezeit = 1 
	; Kamera drehen
	TurnEntity campivot,0,-0.05,0
	PositionEntity camera,EntityX(campivot),EntityY(campivot),EntityZ(campivot)
	RotateEntity camera,EntityPitch#(camera),EntityYaw#(campivot),0
	RotateEntity campivot,0,EntityYaw(campivot),0
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Start-Ansicht nach renderworld
; -----------------------------------------------------------------------------------------------
Function Titelbild()
	Local i, mx, my, mz, wahl
	;-------------------------
	DrawBlock titel,scrW-200,scrH + 100
	mx = MouseX()
	my = MouseY()
	mz = MouseHit(1)
	If KeyHit(28) Or KeyHit(57) Then mz = 1
	If mx > scrW-119 And mx < scrW-2 Then
		If my > scrH+170 And my < scrH+189 Then ; Start
			Color 0,155,0
			Rect scrW-119,scrH+171,117,17,1
			wahl = 1
			If mz Then Ballstart()
		EndIf
		If my > scrH+190 And my < scrH+209 Then ; Hilfe
			Color 0,155,0
			Rect scrW-119,scrH+191,117,17,1
			wahl = 2
			If mz Then FlushKeys() : punkt = 1
		EndIf
		If my > scrH+210 And my < scrH+229 Then ; Optionen
			Color 0,155,0
			Rect scrW-119,scrH+211,117,17,1
			wahl = 3
			If mz Then
				; nur beim ersten Aufruf!
				If erstesmal = 0 Then
					erstesmal = 1
					Get_GFXModes() ; Graphikmodi auslesen
					For i = 1 To anzGfx ; aktuellen gfxMode suchen
						If scrW*2 = gfx3D(i,1) And scrH*2 = gfx3D(i,2) And scrD = gfx3D(i,3) Then zgfx = i : Exit
					Next
				EndIf
				FlushKeys()
				punkt = 4
				MoveMouse scrW+63,scrH+190
			EndIf
		EndIf
	EndIf
	If mx > scrW+10 And mx < scrW+128 Then
		If my > scrH+170 And my < scrH+189 Then ; Spiel laden
			Color 0,155,0
			Rect scrW+11,scrH+171,117,17,1
			wahl = 4
			If mz Then
				; 3 Speicher-Bilder laden
				Bild1 = LoadImage("Save\Speicher1.bmp") : If Bild1 > 0 Then bild1da = 1
				Bild2 = LoadImage("Save\Speicher2.bmp") : If Bild2 > 0 Then bild2da = 1
				Bild3 = LoadImage("Save\Speicher3.bmp") : If Bild3 > 0 Then bild3da = 1
				; nix gespeichert
				If bild1da + bild2da + bild3da = 0 Then
					Meldung("Kein Spiel gespeichert.")
					punkt = 0
				Else
					punkt = 5 ; MLaden()
				EndIf
			EndIf
		EndIf
		If my > scrH+190 And my < scrH+209 Then ; Highscore
			Color 0,155,0
			Rect scrW+11,scrH+191,117,17,1
			wahl = 5
			If mz Then loeschen = 0 : punkt = 6
		EndIf
		If my > scrH+210 And my < scrH+229 Then ; Programm-Ende
			Color 170,0,0
			Rect scrW+11,scrH+211,117,17,1
			wahl = 6
			If mz Then weiter = 0
		EndIf
	EndIf
	Schrift("Start     Spiel laden",scrW-90,scrH+170)
	Schrift("Hilfe",scrW-88,scrH+190)
	Schrift("Highscore",scrW+20,scrH+190)
	Schrift("Optionen",scrW-105,scrH+211)
	Schrift("Ende",scrW+45,scrH+211)
	DrawImage pointer,mx,my
	; Tastatur
	If KeyHit(1) Then weiter = 0 ; ESC = Programm-Ende
	If KeyHit(208) Then ; runter
		Select wahl
			Case 0,1,2
				MoveMouse scrW-55,scrH+180+wahl*20
			Case 3,4,5
				MoveMouse scrW+55,scrH+180+(wahl-3)*20
			Case 6
				MoveMouse scrW-55,scrH+180
		End Select
	EndIf
	If KeyHit(200) Then ; hoch
		Select wahl
			Case 0
				MoveMouse scrW-55,scrH+180
			Case 1
				MoveMouse scrW+55,scrH+220
			Case 2,3,4
				MoveMouse scrW-55,scrH+180+(wahl-2)*20
			Case 5,6
				MoveMouse scrW+55,scrH+180+(wahl-5)*20
		End Select
	EndIf
	If KeyHit(205) Then ; rechts
		If wahl > 0 And wahl < 4 Then MoveMouse scrW+55,my
	EndIf
	If KeyHit(203) Then ; links
		If wahl > 3 And wahl < 7 Then MoveMouse scrW-55,my
	EndIf
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Optionen
; -----------------------------------------------------------------------------------------------
Function Optionen()
	Local mx, my, mz, i, j, k, achtung
	;----------------------------------
	mx = MouseX()
	my = MouseY()
	If KeyHit(28) Or KeyHit(57) Or MouseHit(1) Then mz = 1
	;
	Color 255,0,0
	Rect scrW-348,scrH-168,696,396,0
	Color 255,255,255
	Rect scrW-350,scrH-170,700,400,0
	If KeyHit(60) Then massiv = 1 - massiv
	If massiv Then
		Color 0,70,0
		Rect scrW-347,scrH-167,694,394,1
	EndIf
	Schrift2("OPTIONEN",scrW-45,scrH-130)
	;
	If KeyHit(205) Then ; rechts
		If mx = scrW+63 And my = srH+188 Then
		Else
			mx = mx + 185
			If mx > scrW + 248 Then mx = scrW+248
			MoveMouse mx,my
		EndIf
	EndIf
	If KeyHit(203) Then ; links
		If mx = scrW+63 And my = srH+188 Then
		Else
			mx = mx - 185
			If mx < scrW + 63 Then mx = scrW+63
			MoveMouse mx,my
		EndIf
	EndIf
	If KeyHit(208) Then ; runter
		If mx < scrW + 63 Then mx = scrW + 63
		If mx > scrW + 248 Then mx = scrW + 248
		my = my + 30
		If my > scrH+120 Then
			If mx <> scrW+63 Then mx = scrW+63
			my = scrH+190
		EndIf
		If my > scrH+190 Then my = scrH-60
		MoveMouse mx,my
	EndIf
	If KeyHit(200) Then ; hoch
		If mx < scrW + 63 Then mx = scrW + 63
		If mx > scrW + 248 Then mx = scrW + 248
		my = my - 30
		If my < scrH-60 Then
			If mx <> scrW+63 Then mx = scrW+63
			my = scrH+190
		EndIf
		If my < scrH+190 And my > scrH+120 Then my = scrH+120
		MoveMouse mx,my
	EndIf
	;
	Schrift2("Training / Turnier      (F8)",scrW-290,scrH-70)
	DrawImage rahmen2,scrW+20,scrH-70
	If training = 1 Then
		Schrift2("Training",scrW+110,scrH-70)
	Else
		Schrift2("Turnier",scrW+110,scrH-70)
	EndIf
	If my > scrH-70 And my < scrH-52 Then
		If mx > scrW+20 And mx < scrW+90 Then
			Color 250,250,0
			Rect scrW+20,scrH-70,70,18,1
			If mz Then
				mz = 0
				training = 1 - training
				If training = 0 And bahn > 1 Then bahn = 1 : achtung = 3
			EndIf
		EndIf
		If mx > scrW+225 And mx < scrW+295 Then
			Color 250,250,0
			Rect scrW+225,scrH-70,70,18,1
			If mz Then
				mz = 0
				training = 1 - training
				If training = 0 And bahn > 1 Then bahn = 1 : achtung = 3
			EndIf
		EndIf
	EndIf
	;
	If my > scrH-40 And my < scrH-22 Then
		If mx > scrW+20 And mx < scrW+90 Then
			Color 250,250,0
			Rect scrW+20,scrH-40,70,18,1
			If mz Then
				mz = 0
				If training = 1 Then
					; Verzeichnis da?
					If FileType("Bahnen\Bahn"+Str$(bahn-1)) = 2 Then
						bahn = bahn - 1
					Else
						If FileType("Bahnen\Bahn18") = 2 Then
							bahn = 18
						Else
							achtung = 4
						EndIf
					EndIf				
				Else
					achtung = 3
				EndIf
			EndIf
		EndIf
		If mx > scrW+225 And mx < scrW+295 Then
			Color 250,250,0
			Rect scrW+225,scrH-40,70,18,1
			If mz Then
				mz = 0
				If training = 1 Then
					If FileType("Bahnen\Bahn"+Str$(bahn+1)) = 2 Then
						bahn = bahn + 1
					Else
						If FileType("Bahnen\Bahn1") = 2 Then
							bahn = 1
						Else
							achtung = 4
						EndIf
					EndIf
				Else
					achtung = 3
				EndIf
			EndIf
		EndIf
	EndIf
	Schrift2("Bahnwahl im Training  (1,2...)",scrW-290,scrH-40)
	DrawImage rahmen2,scrW+20,scrH-40
	Schrift2(Str$(bahn),scrW+145,scrH-40)
	;
	Schrift2("Blickwinkel             (F2)",scrW-290,scrH-10)
	DrawImage rahmen2,scrW+20,scrH-10
	If blickwahl = 0 Then
		Schrift2("Abschlag",scrW+110,scrH-10)
	ElseIf blickwahl = 1 Then
		Schrift2("2-D",scrW+135,scrH-10)
	EndIf
	If my > scrH-10 And my < scrH+8 Then
		If mx > scrW+20 And mx < scrW+90 Then
			Color 250,250,0
			Rect scrW+20,scrH-10,70,18,1
			If mz Then mz = 0 : blickwahl = blickwahl - 1 : If blickwahl < 0 Then blickwahl = 1
		EndIf
		If mx > scrW+225 And mx < scrW+295 Then
			Color 250,250,0
			Rect scrW+225,scrH-10,70,18,1
			If mz Then mz = 0 : blickwahl = blickwahl + 1 : If blickwahl > 1 Then blickwahl = 0
		EndIf
	EndIf
	;
	Schrift2("Blickvernderungen automatisch",scrW-290,scrH+16)
	Schrift2("zum Abschlag zurckstellen",scrW-290,scrH+30)
	DrawImage rahmen2,scrW+20,scrH+20
	If rueckstellen = 0 Then
		Schrift2("nein",scrW+130,scrH+20)
	Else
		Schrift2("ja",scrW+140,scrH+20)
	EndIf
	If my > scrH+20 And my < scrH+38 Then
		If mx > scrW+20 And mx < scrW+90 Then
			Color 250,250,0
			Rect scrW+20,scrH+20,70,18,1
			If mz Then
				rueckstellen = 1 - rueckstellen
				mz = 0
			EndIf
		EndIf
		If mx > scrW+225 And mx < scrW+295 Then
			Color 250,250,0
			Rect scrW+225,scrH+20,70,18,1
			If mz Then
				rueckstellen = 1 - rueckstellen
				mz = 0
			EndIf
		EndIf
	EndIf
	;
	Schrift2("Hinweise an/aus        (F11)",scrW-290,scrH+50)
	DrawImage rahmen2,scrW+20,scrH+50
	If hinweise = 0 Then
		Schrift2("alles aus",scrW+103,scrH+50)
	ElseIf hinweise = 1 Then
		Schrift2("nur Schrift",scrW+97,scrH+50)
	ElseIf hinweise = 2 Then
		Schrift2("alles an",scrW+108,scrH+50)
	EndIf
	If my > scrH+50 And my < scrH+68 Then
		If mx > scrW+20 And mx < scrW+90 Then
			Color 250,250,0
			Rect scrW+20,scrH+50,70,18,1
			If mz Then
				hinweise = hinweise + 1
				If hinweise > 2 Then hinweise = 0
				mz = 0
			EndIf
		EndIf
		If mx > scrW+225 And mx < scrW+295 Then
			Color 250,250,0
			Rect scrW+225,scrH+50,70,18,1
			If mz Then
				hinweise = hinweise - 1
				If hinweise < 0 Then hinweise = 2
				mz = 0
			EndIf
		EndIf
	EndIf
	;
	Schrift2("Sound an/aus            (F7)",scrW-290,scrH+80)
	DrawImage rahmen2,scrW+20,scrH+80
	If soundon = 1 Then
		Schrift2("an",scrW+140,scrH+80)
	Else
		Schrift2("aus",scrW+135,scrH+80)
	EndIf
	If my > scrH+80 And my < scrH+98 Then
		If mx > scrW+20 And mx < scrW+90 Then
			Color 250,250,0
			Rect scrW+20,scrH+80,70,18,1
			If mz Then soundon = 1 - soundon : mz = 0
		EndIf
		If mx > scrW+225 And mx < scrW+295 Then
			Color 250,250,0
			Rect scrW+225,scrH+80,70,18,1
			If mz Then soundon = 1 - soundon : mz = 0
		EndIf
	EndIf
	;
	Schrift2("Bildschirm-Auflsung (Pixel)",scrW-290,scrH+110)
	Schrift2("derzeit: "+Str$(scrW*2)+","+Str$(scrH*2)+","+Str$(scrD),scrW-290,scrH+130)
	Schrift2("(beim nchsten Programmstart)",scrW+5,scrH+130)
	DrawImage rahmen2,scrW+20,scrH+110
	If my > scrH+110 And my < scrH+128 Then
		If mx > scrW+20 And mx < scrW+90 Then
			Color 250,250,0
			Rect scrW+20,scrH+110,70,18,1
			If mz Then
				mz = 0
				zgfx = zgfx - 1
				If zgfx < 1 Then zgfx = 1 : achtung = 1
				aktW = Gfx3D(zgfx,1)
				aktH = Gfx3D(zgfx,2)
				aktD = Gfx3D(zgfx,3)
			EndIf
		EndIf
		If mx > scrW+225 And mx < scrW+295 Then
			Color 250,250,0
			Rect scrW+225,scrH+110,70,18,1
			If mz Then
				mz = 0
				zgfx = zgfx + 1
				If zgfx > anzGfx Then zgfx = anzGfx : achtung = 2
				aktW = Gfx3D(zgfx,1)
				aktH = Gfx3D(zgfx,2)
				aktD = Gfx3D(zgfx,3)
			EndIf
		EndIf
	EndIf
	Schrift(Str$(aktW)+","+Str$(aktH)+","+Str$(aktD),scrW+95,scrH+110)
	; raus
	Schrift2("weiter",scrW-35,scrH+180)
	DrawImage rahmen3,scrW-137,scrH+180
	If my > scrH+180 And my < scrH+198 Then
		If mx > scrW-137 And mx < scrW+136 Then
			Color 250,250,0
			Rect scrW-137,scrH+181,70,17,1
			Rect scrW+68,scrH+181,70,17,1
			If mz Then punkt = 0 ; weiter
		EndIf
	EndIf
	; Hinweise
	If achtung > 0 Then
		i = MilliSecs() + 1250
		While i > MilliSecs()
			Color 200,0,0
			Rect scrW-290,scrH-100,585,18,1
			Select achtung
				Case 1
					Schrift("Auflsungen kleiner 800 X 600 machen keinen Sinn.",scrW-240,scrH-100)
				Case 2
					Schrift("Maximale Auflsung.",scrW-85,scrH-100)
				Case 3
					Schrift("Bahn im Turnier nicht whlbar.",scrW-140,scrH-100)
				Case 4
					Schrift("Keine Bahn mehr gefunden.",scrW-120,scrH-100)
			End Select
			Flip
		Wend
		achtung = 0
	EndIf
	DrawImage pointer,mx,my
	;
	If KeyHit(67) Then SShot() ; F9 = Screenshot
	If KeyHit(1) Then punkt = 0
	If punkt = 0 Then
		MoveMouse scrW-30,scrH+180
		While KeyDown(1) Or MouseDown(1)
		Wend
		FlushMouse()
		FlushKeys()
	EndIf
End Function
;
;
; -----------------------------------------------------------------------------------------------
; INI-Datei lesen
; -----------------------------------------------------------------------------------------------
Function Ini_Lesen()
	Local infile, command$
	;----------------------
	infile = ReadFile("Minigolf.ini")
	If infile
		While Not Eof(infile)
			commands$ = ReadLine(infile)
			If Instr(commands$,"Screenwidth=") Then scrW = Right$(commands$,Len(commands$)-12)
			If Instr(commands$,"Screenheight=") Then scrH = Right$(commands$,Len(commands$)-13)
			If Instr(commands$,"Screendepth=") Then scrD = Right$(commands$,Len(commands$)-12)
			If Instr(commands$,"Soundon=") Then soundon = Right$(commands$,Len(commands$)-8)
			If Instr(commands$,"Hinweise=") Then hinweise = Right$(commands$,Len(commands$)-9)
			If Instr(commands$,"Showfps=") Then showfps = Right$(commands$,Len(commands$)-8)
			If Instr(commands$,"Training=") Then training = Right$(commands$,Len(commands$)-9)
			If Instr(commands$,"Blickwahl=") Then blickwahl = Right$(commands$,Len(commands$)-10)
			If Instr(commands$,"zurueckstellen=") Then rueckstellen = Right$(commands$,Len(commands$)-15)
			If Instr(commands$,"Mausempfindlichkeit=") Then mausempf# = Right$(commands$,Len(commands$)-20)
			If Instr(commands$,"Mausrad=") Then mausdreh = Right$(commands$,Len(commands$)-8)
		Wend
		CloseFile(infile)
		; Korrekturen
		If hinweise > 2 Then hinweise = 2
		If hinweise < 0 Then hinweise = 0
		If soundon > 1 Then soundon = 1
		If soundon < 0 Then soundon = 0
		If showfps > 1 Then showfps = 1
		If showfps < 0 Then showfps = 0
		If training > 1 Then training = 1
		If training < 0 Then training = 0
		If blickwahl > 1 Then blickwahl = 1
		If blickwahl < 0 Then blickwahl = 0
		If rueckstellen > 1 Then rueckstellen = 1
		If rueckstellen < 0 Then rueckstellen = 0
		If mausdreh > 90 Then mausdreh = 90 
		If mausdreh < -90 Then mausdreh = -90
		If mausempf# > 1 Then mausempf# = 1  
		If mausempf# < -1 Then mausempf# = -1  
	EndIf
End Function
;
;
; -----------------------------------------------------------------------------------------------
; INI-Datei schreiben
; -----------------------------------------------------------------------------------------------
Function Ini_schreiben()
	Local outfile
	;-------------
	outfile = WriteFile("Minigolf.ini")
	If outfile Then
		WriteLine(outfile,"Screenwidth=" +Str$(aktW))
		WriteLine(outfile,"Screenheight="+Str$(aktH))
		WriteLine(outfile,"Screendepth="+Str$(aktD))
		WriteLine(outfile,"Soundon="+Str$(soundon))
		WriteLine(outfile,"Hinweise="+Str$(hinweise))
		WriteLine(outfile,"Showfps="+Str$(showfps))
		WriteLine(outfile,"Training="+Str$(training))
		WriteLine(outfile,"Blickwahl="+Str$(blickwahl))
		WriteLine(outfile,"zurueckstellen="+Str$(rueckstellen))
		WriteLine(outfile,"Mausempfindlichkeit="+Str$(mausempf#))
		WriteLine(outfile,"Mausrad="+Str$(mausdreh))
		CloseFile(outfile)
;		Meldung("Minigolf.ini ist geschrieben.")
	Else
		Meldung("Fehler. Minigolf.ini schreibgeschtzt?")
	EndIf	
End Function
;
;
; ---------------------------------------------------------------------------------------------
; moegliche Bildschirmaufloesung ermitteln
; ---------------------------------------------------------------------------------------------
Function Get_GFXModes()
	Local i, j, anzGfxalt
	;--------------------
	anzGfxalt = anzGfx
	j = 0
	For i = 1 To anzGfxalt
		If GfxMode3D(i) Then
			If GfxModeWidth(i) >= 800 And GfxModeHeight(i) >= 600 Then j = j + 1 
		EndIf
	Next
	; nur mindestens 800 x 600 Pixel
	anzGfx = j
	Dim Gfx3D(anzGfx,3)
	j = 1
	For i = 1 To anzGfxalt
		If GfxMode3D(i) Then
			If GfxModeWidth(i) >= 800 And GfxModeHeight(i) >= 600 Then
				Gfx3D(j,1) = GfxModeWidth(i)
				Gfx3D(j,2) = GfxModeHeight(i)
				Gfx3D(j,3) = GfxModeDepth(i)
				j = j + 1
			EndIf
		EndIf
	Next
End Function
;
;
; -----------------------------------------------------------------------------------------------
; Medien laden...
; -----------------------------------------------------------------------------------------------
Function MedienLaden()
	; Gebiet
	terr  = LoadTerrain( "gfx\hmap.png" ) : If terr = 0 Then RuntimeError "Bild 'gfx\hmap.png' fehlt."
	tex = LoadTexture("gfx\gPutz4.png") : If tex = 0 Then RuntimeError "Bild 'gfx\gPutz4.png' fehlt"
	ScaleTexture tex,4,4
	EntityFX terr,1
	ScaleEntity terr,2,40,2
	EntityTexture terr,tex,0,0
	TerrainDetail terr,2000,1
	PositionEntity terr,-100,-31.2,-100
	tex2 = LoadTexture( "gfx\glmap.png" ) : If tex2 = 0 Then RuntimeError "Bild 'gfx\glmap.png' fehlt."
	ScaleTexture tex2,TerrainSize(terr),TerrainSize(terr)
	EntityTexture terr,tex2,0,1
	FreeTexture tex : tex = 0
	FreeTexture tex2 : tex2 = 0
	; Wasser
	p = CreatePlane()
	EntityBlend p,1
	tex = LoadTexture( "gfx\cloud_2.png",3 ) : If tex = 0 Then RuntimeError "Bild 'gfx\cloud_2.png' fehlt."
	ScaleTexture tex,100,100
	EntityColor p,60,60,250
	EntityTexture p,tex
	PositionEntity p,0,-1,0
	EntityFX p,1
	FreeTexture tex : tex = 0
	; Wolken
	tex = LoadTexture( "gfx\cloud_4.png",3 ) : If tex = 0 Then RuntimeError "Bild 'gfx\cloud_4.png' fehlt."
	ScaleTexture tex,1000,1000
	himmel = CreatePlane()
	EntityTexture himmel,tex
	EntityFX himmel,1
	PositionEntity himmel,0,90,0
	RotateEntity himmel,0,0,180
	FreeTexture tex : tex = 0
	; Ball
	ball = CreateSphere()
	ScaleMesh ball,0.16,0.16,0.16
	tex = LoadTexture("gfx\balltex.png") : If tex = 0 Then RuntimeError "Bild 'gfx\balltex.png' fehlt"
	EntityTexture ball,tex
	FreeTexture tex : tex = 0
	EntityRadius ball,0.16,0.16
	EntityShininess ball,1
	EntityFX ball,1
	EntityType ball,COLL_BALL
	HideEntity ball
	; Schlaeger
	putter = LoadMesh("Bahnen\Schlaeger.b3d") : If putter = 0 Then RuntimeError "Modell 'Bahnen\Schlaeger.b3d' fehlt"
	; Pfeil
	pfeil = LoadMesh("Bahnen\Pfeil.b3d") : If Pfeil = 0 Then RuntimeError "Modell 'Bahnen\Pfeil.b3d' fehlt"
	; Lampe
	lampe = LoadMesh("Bahnen\Lampe.b3d") : If lampe = 0 Then RuntimeError "Modell '"+temp$+"Bahnen\Lampe.b3d' fehlt"
	PositionEntity lampe,5,0,35
	; Bahnattrappen
	gesamt2 = LoadMesh("Bahnen\Bahn5\Bahn5.b3d") : If gesamt2 = 0 Then RuntimeError "Modell '"+temp$+"Bahnen\Bahn5\Bahn5.b3d' fehlt"
	RotateEntity gesamt2,0,90,0
	MoveEntity gesamt2,25,-0.2,65
	gesamt3 = LoadMesh("Bahnen\Bahn3\Bahn3.b3d") : If gesamt3 = 0 Then RuntimeError "Modell '"+temp$+"Bahnen\Bahn3\Bahn3.b3d' fehlt"
	RotateEntity gesamt3,0,60,0
	MoveEntity gesamt3,40,-0.2,35
	gesamt4 = LoadMesh("Bahnen\Bahn4\Bahn4.b3d") : If gesamt4 = 0 Then RuntimeError "Modell 'Bahnen\Bahn4\Boden.b3d' fehlt"
	RotateEntity gesamt4,0,120,0
	MoveEntity gesamt4,100,-0.2,-10
	gesamt7 = LoadMesh("Bahnen\Bahn7\Bahn7.b3d") : If gesamt7 = 0 Then RuntimeError "Modell 'Bahnen\Bahn7\Bahn7.b3d' fehlt"
	MoveEntity gesamt7,50,-0.2,55
	gesamt8 = LoadMesh("Bahnen\Bahn10\Bahn10.b3d") : If gesamt8 = 0 Then RuntimeError "Modell 'Bahnen\Bahn10\Bahn10.b3d' fehlt"
	MoveEntity gesamt8,-45,-0.2,-45
	gesamt9 = LoadMesh("Bahnen\Bahn17\Bahn17.b3d") : If gesamt9 = 0 Then RuntimeError "Modell 'Bahnen\Bahn17\Bahn17.b3d' fehlt"
	RotateEntity gesamt9,0,10,0
	MoveEntity gesamt9,20,-0.2,-50
	; Nessie
	nessiebauch = LoadMesh("Bahnen\Nessiebauch.b3d") : If nessiebauch = 0 Then RuntimeError "Modell 'Bahnen\Nessiebauch.b3d' fehlt"
	ScaleEntity nessiebauch,0.2,0.2,0.2
	PositionEntity nessiebauch,100,-8,0
	HideEntity nessiebauch
	nessiekopf = LoadMesh("Bahnen\Nessiekopf.b3d") : If nessiekopf = 0 Then RuntimeError "Modell 'Bahnen\Nessiekopf.b3d' fehlt"
	ScaleEntity nessiekopf,0.2,0.2,0.2
	PositionEntity nessiekopf,100,-8,0
	HideEntity nessiekopf
	nessiezunge = LoadMesh("Bahnen\Nessiezunge.b3d") : If nessiezunge = 0 Then RuntimeError "Modell 'Bahnen\Nessiezunge.b3d' fehlt"
	ScaleEntity nessiezunge,0.2,0.2,0.2
	PositionEntity nessiezunge,100,-8,0
	EntityAlpha nessiezunge,0
	HideEntity nessiezunge
	; Gebuesch
	gebuesch = LoadSprite("gfx\gebuesch.png",7) : If gebuesch = 0 Then RuntimeError "Bild 'gfx\gebuesch.png' fehlt."
	SpriteViewMode gebuesch,2
	EntityFX gebuesch,17
	ScaleSprite gebuesch,10,4
	PositionEntity gebuesch,25,3,30
	; 90 Grad versetzt
	gebuesch6 = CopyEntity(gebuesch)
	RotateEntity gebuesch6,0,15,0
	PositionEntity gebuesch6,25,3,30
	; 2. Gebuesch
	gebuesch2 = CopyEntity(gebuesch)
	PositionEntity gebuesch2,-35,1,55
	; 90 Grad versetzt
	gebuesch5 = CopyEntity(gebuesch)
	RotateEntity gebuesch5,0,15,0
	PositionEntity gebuesch5,-35,1,55
	; 3. Gebuesch
	gebuesch3 = CopyEntity(gebuesch)
	ScaleSprite gebuesch3,20,5
	PositionEntity gebuesch3,5,4,-60
	; 90 Grad versetzt
	gebuesch4 = CopyEntity(gebuesch)
	ScaleSprite gebuesch4,20,5
	RotateEntity gebuesch4,0,15,0
	PositionEntity gebuesch4,5,4,-60
	; Baum
	gbaum = LoadSprite("gfx\gbaum.png",7) : If gbaum = 0 Then RuntimeError "Bild 'gfx\gbaum.png' fehlt."
	SpriteViewMode gbaum,2
	EntityFX gbaum,17
	ScaleSprite gbaum,3,7
	RotateEntity gbaum,0,90,0
	PositionEntity gbaum,-45,7,-30
	gbaum2 = CopyEntity(gbaum)
	ScaleSprite gbaum2,3,5
	PositionEntity gbaum2,-50,5,-20
	; 90 Grad versetzt
	gbaum3 = CopyEntity(gbaum)
	RotateEntity gbaum3,0,180,0
	PositionEntity gbaum3,-45,7,-30
	gbaum4 = CopyEntity(gbaum2)
	RotateEntity gbaum4,0,180,0
	PositionEntity gbaum4,-50,5,-20
	; Baum in der anderen Richtung
	gbaum5 = CopyEntity(gbaum)
	ScaleSprite gbaum5,4,8
	PositionEntity gbaum5,40,7.5,80
	gbaum6 = CopyEntity(gbaum5)
	RotateEntity gbaum6,0,180,0
	PositionEntity gbaum6,40,7.5,80
	; Segelboot
	boot = LoadSprite("gfx\boot.png",7) : If boot = 0 Then RuntimeError "Bild 'gfx\boot.png' fehlt."
	SpriteViewMode boot,2
	EntityFX boot,17
	ScaleSprite boot,5,5
	RotateEntity boot,0,90,0
	PositionEntity boot,250,3.5,-100
	; Schiff
	schiff = LoadSprite("gfx\schiff.png",7) : If schiff = 0 Then RuntimeError "Bild 'gfx\schiff.png' fehlt."
	SpriteViewMode schiff,2
	EntityFX schiff,17
	ScaleSprite schiff,25,7
	PositionEntity schiff,-50,4,-400
	; Feuerwerk
	feuer = LoadTexture("gfx\feuer.png",2) : If feuer = 0 Then RuntimeError "Bild 'gfx\feuer.png' fehlt."
	spritzer = LoadTexture("gfx\spritzer.png",2) : If spritzer = 0 Then RuntimeError "Bild 'gfx\spritzer.png' fehlt."
	rauch = LoadTexture("gfx\rauch.png",2) : If rauch = 0 Then RuntimeError "Bild 'gfx\rauch.png' fehlt."
	powerup = LoadSprite("gfx\powerup.png",2) : If powerup = 0 Then RuntimeError "Bild 'gfx\powerup.png' fehlt."
	TurnEntity powerup,80,0,0
	EntityBlend powerup,3
	HideEntity powerup
	; Lampe 'anschalten'
	sLampe = LoadSprite("gfx\Lampe.png",2) : If sLampe = 0 Then RuntimeError "Bild 'gfx\Lampe.png' fehlt."
	EntityBlend sLampe,3
	EntityFX sLampe,17
	SpriteViewMode sLampe,2
	l1 = CopyEntity(sLampe)
	RotateEntity l1,0,90,0
	l2 = CopyEntity(sLampe)
	l3 = CopyEntity(sLampe)
	RotateEntity l3,0,90,0
	PositionEntity l1,7.2,13.5,35
	PositionEntity sLampe,7.2,13.5,35
	PositionEntity l2,2.8,13.5,35
	PositionEntity l3,2.8,13.5,35
	; Maus
	maus = LoadMesh("Bahnen\Maus.b3d") : If maus = 0 Then RuntimeError "Modell 'Bahnen\Maus.b3d' fehlt"
	PositionEntity maus,0,-0.2,0
	HideEntity maus
	; Vogel
	flug1 = LoadMesh("Bahnen\flug1.b3d") : If flug1 = 0 Then RuntimeError "Modell 'Bahnen\flug1.b3d' fehlt"
	ScaleEntity flug1,0.2,0.2,0.2
	HideEntity flug1
	flug2 = LoadMesh("Bahnen\flug2.b3d") : If flug2 = 0 Then RuntimeError "Modell 'Bahnen\flug2.b3d' fehlt"
	ScaleEntity flug2,0.2,0.2,0.2
	HideEntity flug2
	rumpf = LoadMesh("Bahnen\rumpf.b3d") : If rumpf = 0 Then RuntimeError "Modell 'Bahnen\rumpf.b3d' fehlt"
	ScaleEntity rumpf,0.2,0.2,0.2
	HideEntity rumpf
	absturz = LoadMesh("Bahnen\absturz.b3d") : If absturz = 0 Then RuntimeError "Modell 'Bahnen\absturz.b3d' fehlt"
	ScaleEntity absturz,0.2,0.2,0.2
	HideEntity absturz
	; Bilder
	max6 = LoadImage("gfx\max6.png") : If max6 = 0 Then RuntimeError "Bild 'gfx\max6.png' fehlt"
	WEnde = LoadImage("gfx\WEnde.png") : If WEnde = 0 Then RuntimeError "Bild 'gfx\WEnde.png' fehlt"
	rahmen = LoadImage("gfx\rahmen.png") : If rahmen = 0 Then RuntimeError "Bild 'gfx\rahmen.png' fehlt"
	rahmen2 = LoadImage("gfx\rahmen2.png") : If rahmen2 = 0 Then RuntimeError "Bild 'gfx\rahmen2.png' fehlt"
	rahmen3 = LoadImage("gfx\rahmen3.png") : If rahmen3 = 0 Then RuntimeError "Bild 'gfx\rahmen3.png' fehlt"
	power = LoadImage("gfx\power.png") : If power = 0 Then RuntimeError "Bild 'gfx\power.png' fehlt"
	titel = LoadImage("gfx\titel.png") : If titel = 0 Then RuntimeError "Bild 'gfx\titel.png' fehlt"
	maus2 = LoadImage("gfx\maus.png") : If maus2 = 0 Then RuntimeError "Bild 'gfx\maus.png' fehlt"
	speichern = LoadImage("gfx\speichern.png") : If speichern = 0 Then RuntimeError "Bild 'gfx\speichern.png' fehlt"
	pointer = LoadImage("gfx\pointer.png") : If pointer = 0 Then RuntimeError "Bild 'gfx\pointer.png' fehlt"
	pointerJa = LoadImage("gfx\pointerja.png") : If pointerja = 0 Then RuntimeError "Bild 'gfx\pointerja.png' fehlt"
	pointerNein = LoadImage("gfx\pointernein.png") : If pointernein = 0 Then RuntimeError "Bild 'gfx\pointernein.png' fehlt"
	txtspeichern = LoadImage("gfx\txtspeichern.png") : If txtspeichern = 0 Then RuntimeError "Bild 'gfx\txtspeichern.png' fehlt"
	txtladen = LoadImage("gfx\txtladen.png") : If txtladen = 0 Then RuntimeError "Bild 'gfx\txtladen.png' fehlt"
	txtfrei = LoadImage("gfx\freigeben.png") : If txtfrei = 0 Then RuntimeError "Bild 'gfx\freigeben.png' fehlt"
	Tasten = LoadImage("gfx\Tasten.png") : If Tasten = 0 Then RuntimeError "Bild 'gfx\Tasten.png' fehlt"
	T1 = LoadImage("gfx\T1.png") : If T1 = 0 Then RuntimeError "Bild 'gfx\T1.png' fehlt"
	T2 = LoadImage("gfx\T2.png") : If T2 = 0 Then RuntimeError "Bild 'gfx\T2.png' fehlt"
	; Schrift
	fntcouNew8f = LoadAnimImage("gfx\fntcouNew8f.png",20,20,0,223) : If fntcouNew8f = 0 Then RuntimeError "Bild 'gfx\fntcouNew8f.png' fehlt."
	; Sound
	sfxwallhit = LoadSound("sfx\wallhit.wav")
	sfxbathit = LoadSound("sfx\bathit.wav")
	sfxgolfball = LoadSound("sfx\golfball.wav")
	sfxping1 = LoadSound("sfx\ping1.wav")
	sfxflash = LoadSound("sfx\flashbulb.wav")
	sfxpipe = LoadSound("sfx\pipebang.wav")
	sfxmaus = LoadSound("sfx\soundfx7.wav")
	sfxwater = LoadSound("sfx\watersplash.wav")
	sfxwater2 = LoadSound("sfx\water.mp3")
End Function

; ENDE -------------------------------------------------------------------------------------------